<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks® NonCommercial, 7.4.1 of mardi 30 mai 2006 on mardi 12 juin 2007 at 9:34:53</time-stamp>


<name-space>
<name>Orizi</name>
<environment>CormasNS.Models</environment>
<private>false</private>
<imports>
			private Smalltalk.*
			private CormasNS.Kernel.*
			</imports>
<category>OriziCategory</category>
<attributes>
<package>Orizi</package>
</attributes>
</name-space>


<class>
<name>Farmer</name>
<environment>CormasNS.Models.Orizi</environment>
<super>CormasNS.Kernel.AgentCommLocation</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>name field labor behaviour satisfaction memory motivation irrigation objective </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Cormas-Orizi</category>
<attributes>
<package>Orizi</package>
</attributes>
</class>

<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.Orizi.Farmer</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>Orizi</package>
</attributes>
</shared-variable>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Orizi.Farmer class</class-id> <category>resources</category>

<body package="Orizi" selector="figurine">figurine
	"UIMaskEditor new openOnClass: self andSelector: #figurine"

	&lt;resource: #image&gt;
	^CachedImage on: (Image extent: 31@48 depth: 10 bitsPerPixel: 16 palette: (MappedPalette withColors: ((Array new: 581) at: 1 put: (ColorValue scaledRed: 1541 scaledGreen: 1027 scaledBlue: 1509); at: 2 put: (ColorValue scaledRed: 3565 scaledGreen: 2537 scaledBlue: 2055); at: 3 put: (ColorValue scaledRed: 4079 scaledGreen: 2537 scaledBlue: 1541); at: 4 put: (ColorValue scaledRed: 3565 scaledGreen: 5621 scaledBlue: 7163); at: 5 put: (ColorValue scaledRed: 4593 scaledGreen: 5621 scaledBlue: 6135); at: 6 put: (ColorValue scaledRed: 4593 scaledGreen: 5107 scaledBlue: 6649); at: 7 put: (ColorValue scaledRed: 3051 scaledGreen: 4079 scaledBlue: 5139); at: 8 put: (ColorValue scaledRed: 4079 scaledGreen: 3597 scaledBlue: 4593); at: 9 put: (ColorValue scaledRed: 4593 scaledGreen: 3597 scaledBlue: 4079); at: 10 put: (ColorValue scaledRed: 3597 scaledGreen: 2537 scaledBlue: 2055); at: 11 put: (ColorValue scaledRed: 2569 scaledGreen: 2569 scaledBlue: 3051); at: 12 put: (ColorValue scaledRed: 2569 scaledGreen: 2537 scaledBlue: 3083); at: 13 put: (ColorValue scaledRed: 2023 scaledGreen: 2569 scaledBlue: 3597); at: 14 put: (ColorValue scaledRed: 2537 scaledGreen: 2569 scaledBlue: 3083); at: 15 put: (ColorValue scaledRed: 3565 scaledGreen: 4111 scaledBlue: 4593); at: 16 put: (ColorValue scaledRed: 3083 scaledGreen: 4079 scaledBlue: 5107); at: 17 put: (ColorValue scaledRed: 3565 scaledGreen: 3597 scaledBlue: 5107); at: 18 put: (ColorValue scaledRed: 2537 scaledGreen: 4079 scaledBlue: 5653); at: 19 put: (ColorValue scaledRed: 1541 scaledGreen: 2569 scaledBlue: 4079); at: 20 put: (ColorValue scaledRed: 4625 scaledGreen: 4079 scaledBlue: 3565); at: 21 put: (ColorValue scaledRed: 3597 scaledGreen: 2569 scaledBlue: 2023); at: 22 put: (ColorValue scaledRed: 5107 scaledGreen: 5107 scaledBlue: 6135); at: 23 put: (ColorValue scaledRed: 6649 scaledGreen: 6649 scaledBlue: 7163); at: 24 put: (ColorValue scaledRed: 7163 scaledGreen: 6649 scaledBlue: 6649); at: 25 put: (ColorValue scaledRed: 3597 scaledGreen: 5621 scaledBlue: 7163); at: 26 put: (ColorValue scaledRed: 4079 scaledGreen: 5621 scaledBlue: 6681); at: 27 put: (ColorValue scaledRed: 4593 scaledGreen: 5139 scaledBlue: 6649); at: 28 put: (ColorValue scaledRed: 3565 scaledGreen: 3597 scaledBlue: 5139); at: 29 put: (ColorValue scaledRed: 4111 scaledGreen: 3597 scaledBlue: 4593); at: 30 put: (ColorValue scaledRed: 3083 scaledGreen: 4111 scaledBlue: 5107); at: 31 put: (ColorValue scaledRed: 2055 scaledGreen: 2569 scaledBlue: 3597); at: 32 put: (ColorValue scaledRed: 3597 scaledGreen: 4079 scaledBlue: 4625); at: 33 put: (ColorValue scaledRed: 3597 scaledGreen: 3597 scaledBlue: 5107); at: 34 put: (ColorValue scaledRed: 4593 scaledGreen: 5653 scaledBlue: 6135); at: 35 put: (ColorValue scaledRed: 4079 scaledGreen: 5139 scaledBlue: 7163); at: 36 put: (ColorValue scaledRed: 5653 scaledGreen: 5107 scaledBlue: 5621); at: 37 put: (ColorValue scaledRed: 4625 scaledGreen: 5621 scaledBlue: 6135); at: 38 put: (ColorValue scaledRed: 5107 scaledGreen: 5621 scaledBlue: 5653); at: 39 put: (ColorValue scaledRed: 4593 scaledGreen: 5621 scaledBlue: 6167); at: 40 put: (ColorValue scaledRed: 4111 scaledGreen: 5621 scaledBlue: 6649); at: 41 put: (ColorValue scaledRed: 2569 scaledGreen: 2569 scaledBlue: 3083); at: 42 put: (ColorValue scaledRed: 3083 scaledGreen: 2569 scaledBlue: 2569); at: 43 put: (ColorValue scaledRed: 5139 scaledGreen: 5107 scaledBlue: 6135); at: 44 put: ColorValue white; at: 45 put: (ColorValue scaledRed: 6135 scaledGreen: 7163 scaledBlue: 7195); at: 46 put: (ColorValue scaledRed: 6167 scaledGreen: 7163 scaledBlue: 7163); at: 47 put: (ColorValue scaledRed: 7163 scaledGreen: 6681 scaledBlue: 6649); at: 48 put: (ColorValue scaledRed: 4111 scaledGreen: 5621 scaledBlue: 6681); at: 49 put: (ColorValue scaledRed: 481 scaledGreen: 481 scaledBlue: 481); at: 50 put: (ColorValue scaledRed: 4625 scaledGreen: 5139 scaledBlue: 6649); at: 51 put: (ColorValue scaledRed: 4111 scaledGreen: 3597 scaledBlue: 4625); at: 52 put: (ColorValue scaledRed: 4625 scaledGreen: 5621 scaledBlue: 6167); at: 53 put: (ColorValue scaledRed: 5107 scaledGreen: 5139 scaledBlue: 6167); at: 54 put: (ColorValue scaledRed: 6167 scaledGreen: 5107 scaledBlue: 5139); at: 55 put: (ColorValue scaledRed: 6167 scaledGreen: 7163 scaledBlue: 7195); at: 56 put: (ColorValue scaledRed: 6649 scaledGreen: 6681 scaledBlue: 7195); at: 57 put: (ColorValue scaledRed: 4625 scaledGreen: 5653 scaledBlue: 6167); at: 58 put: (ColorValue scaledRed: 513 scaledGreen: 481 scaledBlue: 481); at: 59 put: (ColorValue scaledRed: 995 scaledGreen: 481 scaledBlue: 0); at: 60 put: (ColorValue scaledRed: 481 scaledGreen: 513 scaledBlue: 481); at: 61 put: (ColorValue scaledRed: 4625 scaledGreen: 5139 scaledBlue: 6681); at: 62 put: (ColorValue scaledRed: 3051 scaledGreen: 3051 scaledBlue: 3565); at: 63 put: (ColorValue scaledRed: 2537 scaledGreen: 3051 scaledBlue: 4079); at: 64 put: (ColorValue scaledRed: 6681 scaledGreen: 6681 scaledBlue: 7195); at: 65 put: (ColorValue scaledRed: 2537 scaledGreen: 1541 scaledBlue: 1509); at: 66 put: (ColorValue scaledRed: 2023 scaledGreen: 1541 scaledBlue: 2023); at: 67 put: (ColorValue scaledRed: 1509 scaledGreen: 2023 scaledBlue: 2055); at: 68 put: (ColorValue scaledRed: 513 scaledGreen: 513 scaledBlue: 481); at: 69 put: (ColorValue scaledRed: 995 scaledGreen: 513 scaledBlue: 0); at: 70 put: (ColorValue scaledRed: 481 scaledGreen: 513 scaledBlue: 513); at: 71 put: (ColorValue scaledRed: 1509 scaledGreen: 1541 scaledBlue: 2537); at: 72 put: (ColorValue scaledRed: 1541 scaledGreen: 2023 scaledBlue: 2023); at: 73 put: (ColorValue scaledRed: 3565 scaledGreen: 3051 scaledBlue: 3051); at: 74 put: (ColorValue scaledRed: 5107 scaledGreen: 4079 scaledBlue: 4593); at: 75 put: (ColorValue scaledRed: 3051 scaledGreen: 4593 scaledBlue: 6135); at: 76 put: (ColorValue scaledRed: 3083 scaledGreen: 3051 scaledBlue: 3565); at: 77 put: (ColorValue scaledRed: 3051 scaledGreen: 3051 scaledBlue: 3597); at: 78 put: (ColorValue scaledRed: 2569 scaledGreen: 3051 scaledBlue: 4079); at: 79 put: (ColorValue scaledRed: 2537 scaledGreen: 1541 scaledBlue: 1541); at: 80 put: (ColorValue scaledRed: 1541 scaledGreen: 2023 scaledBlue: 2055); at: 81 put: (ColorValue scaledRed: 2569 scaledGreen: 1541 scaledBlue: 1509); at: 82 put: (ColorValue scaledRed: 513 scaledGreen: 513 scaledBlue: 513); at: 83 put: (ColorValue scaledRed: 2055 scaledGreen: 2023 scaledBlue: 1541); at: 84 put: (ColorValue scaledRed: 2023 scaledGreen: 3083 scaledBlue: 4593); at: 85 put: (ColorValue scaledRed: 3597 scaledGreen: 3051 scaledBlue: 3051); at: 86 put: (ColorValue scaledRed: 1541 scaledGreen: 1541 scaledBlue: 2537); at: 87 put: (ColorValue scaledRed: 5621 scaledGreen: 5621 scaledBlue: 6649); at: 88 put: (ColorValue scaledRed: 5107 scaledGreen: 5621 scaledBlue: 7163); at: 89 put: (ColorValue scaledRed: 5107 scaledGreen: 6135 scaledBlue: 6649); at: 90 put: (ColorValue scaledRed: 3565 scaledGreen: 4111 scaledBlue: 6135); at: 91 put: (ColorValue scaledRed: 3565 scaledGreen: 4593 scaledBlue: 5653); at: 92 put: (ColorValue scaledRed: 3083 scaledGreen: 4593 scaledBlue: 6135); at: 93 put: (ColorValue scaledRed: 2569 scaledGreen: 3083 scaledBlue: 4079); at: 94 put: (ColorValue scaledRed: 4593 scaledGreen: 2569 scaledBlue: 2569); at: 95 put: (ColorValue scaledRed: 2537 scaledGreen: 3083 scaledBlue: 4111); at: 96 put: (ColorValue scaledRed: 2569 scaledGreen: 3565 scaledBlue: 3597); at: 97 put: (ColorValue scaledRed: 4593 scaledGreen: 4111 scaledBlue: 5107); at: 98 put: (ColorValue scaledRed: 4079 scaledGreen: 4111 scaledBlue: 5621); at: 99 put: (ColorValue scaledRed: 4079 scaledGreen: 4593 scaledBlue: 5139); at: 100 put: (ColorValue scaledRed: 3597 scaledGreen: 4593 scaledBlue: 5621); at: 101 put: (ColorValue scaledRed: 6135 scaledGreen: 5621 scaledBlue: 6135); at: 102 put: (ColorValue scaledRed: 3083 scaledGreen: 3083 scaledBlue: 3565); at: 103 put: (ColorValue scaledRed: 3051 scaledGreen: 4593 scaledBlue: 6167); at: 104 put: (ColorValue scaledRed: 6649 scaledGreen: 7677 scaledBlue: 7677); at: 105 put: (ColorValue scaledRed: 7163 scaledGreen: 7163 scaledBlue: 7677); at: 106 put: (ColorValue scaledRed: 5107 scaledGreen: 6135 scaledBlue: 6681); at: 107 put: (ColorValue scaledRed: 5621 scaledGreen: 5653 scaledBlue: 6649); at: 108 put: (ColorValue scaledRed: 5107 scaledGreen: 5653 scaledBlue: 7163); at: 109 put: (ColorValue scaledRed: 3597 scaledGreen: 4111 scaledBlue: 6135); at: 110 put: (ColorValue scaledRed: 4111 scaledGreen: 4593 scaledBlue: 5139); at: 111 put: (ColorValue scaledRed: 5107 scaledGreen: 4111 scaledBlue: 4625); at: 112 put: (ColorValue scaledRed: 4111 scaledGreen: 2569 scaledBlue: 3083); at: 113 put: (ColorValue scaledRed: 4593 scaledGreen: 4111 scaledBlue: 5139); at: 114 put: (ColorValue scaledRed: 3597 scaledGreen: 4625 scaledBlue: 5621); at: 115 put: (ColorValue scaledRed: 4079 scaledGreen: 4625 scaledBlue: 5139); at: 116 put: (ColorValue scaledRed: 4625 scaledGreen: 4111 scaledBlue: 5107); at: 117 put: (ColorValue scaledRed: 3051 scaledGreen: 4625 scaledBlue: 6167); at: 118 put: (ColorValue scaledRed: 5653 scaledGreen: 5621 scaledBlue: 6649); at: 119 put: (ColorValue scaledRed: 5139 scaledGreen: 6135 scaledBlue: 6649); at: 120 put: (ColorValue scaledRed: 3083 scaledGreen: 4625 scaledBlue: 6135); at: 121 put: (ColorValue scaledRed: 3083 scaledGreen: 4593 scaledBlue: 6167); at: 122 put: (ColorValue scaledRed: 7163 scaledGreen: 7195 scaledBlue: 7677); at: 123 put: (ColorValue scaledRed: 6681 scaledGreen: 7677 scaledBlue: 7677); at: 124 put: (ColorValue scaledRed: 6649 scaledGreen: 7677 scaledBlue: 7709); at: 125 put: (ColorValue scaledRed: 5139 scaledGreen: 6135 scaledBlue: 6681); at: 126 put: (ColorValue scaledRed: 995 scaledGreen: 995 scaledBlue: 995); at: 127 put: (ColorValue scaledRed: 5107 scaledGreen: 5653 scaledBlue: 7195); at: 128 put: (ColorValue scaledRed: 3083 scaledGreen: 4625 scaledBlue: 6167); at: 129 put: (ColorValue scaledRed: 5139 scaledGreen: 4111 scaledBlue: 4625); at: 130 put: (ColorValue scaledRed: 4111 scaledGreen: 4625 scaledBlue: 5139); at: 131 put: (ColorValue scaledRed: 7709 scaledGreen: 7195 scaledBlue: 7163); at: 132 put: (ColorValue scaledRed: 7163 scaledGreen: 7195 scaledBlue: 7709); at: 133 put: (ColorValue scaledRed: 6681 scaledGreen: 7677 scaledBlue: 7709); at: 134 put: (ColorValue scaledRed: 5139 scaledGreen: 6167 scaledBlue: 6681); at: 135 put: (ColorValue scaledRed: 1509 scaledGreen: 1027 scaledBlue: 481); at: 136 put: (ColorValue scaledRed: 995 scaledGreen: 1027 scaledBlue: 995); at: 137 put: (ColorValue scaledRed: 995 scaledGreen: 995 scaledBlue: 1027); at: 138 put: (ColorValue scaledRed: 5139 scaledGreen: 5653 scaledBlue: 7195); at: 139 put: (ColorValue scaledRed: 5653 scaledGreen: 5653 scaledBlue: 6681); at: 140 put: (ColorValue scaledRed: 3051 scaledGreen: 3565 scaledBlue: 4593); at: 141 put: (ColorValue scaledRed: 4079 scaledGreen: 3565 scaledBlue: 3565); at: 142 put: (ColorValue scaledRed: 2569 scaledGreen: 2023 scaledBlue: 2537); at: 143 put: (ColorValue scaledRed: 2537 scaledGreen: 2055 scaledBlue: 2537); at: 144 put: (ColorValue scaledRed: 2023 scaledGreen: 2055 scaledBlue: 3051); at: 145 put: (ColorValue scaledRed: 995 scaledGreen: 1027 scaledBlue: 1027); at: 146 put: (ColorValue scaledRed: 3051 scaledGreen: 2055 scaledBlue: 2023); at: 147 put: (ColorValue scaledRed: 1027 scaledGreen: 1027 scaledBlue: 995); at: 148 put: (ColorValue scaledRed: 2055 scaledGreen: 2537 scaledBlue: 2537); at: 149 put: (ColorValue scaledRed: 3565 scaledGreen: 5107 scaledBlue: 6649); at: 150 put: (ColorValue scaledRed: 5621 scaledGreen: 4593 scaledBlue: 5107); at: 151 put: (ColorValue scaledRed: 4593 scaledGreen: 5107 scaledBlue: 5621); at: 152 put: (ColorValue scaledRed: 3083 scaledGreen: 3565 scaledBlue: 4593); at: 153 put: (ColorValue scaledRed: 3051 scaledGreen: 3565 scaledBlue: 4625); at: 154 put: (ColorValue scaledRed: 4593 scaledGreen: 3597 scaledBlue: 3051); at: 155 put: (ColorValue scaledRed: 3083 scaledGreen: 2055 scaledBlue: 2023); at: 156 put: (ColorValue scaledRed: 2537 scaledGreen: 2055 scaledBlue: 2569); at: 157 put: (ColorValue scaledRed: 2023 scaledGreen: 2055 scaledBlue: 3083); at: 158 put: (ColorValue scaledRed: 1027 scaledGreen: 1027 scaledBlue: 1027); at: 159 put: (ColorValue scaledRed: 2569 scaledGreen: 2055 scaledBlue: 2537); at: 160 put: (ColorValue scaledRed: 2055 scaledGreen: 2055 scaledBlue: 3051); at: 161 put: (ColorValue scaledRed: 4079 scaledGreen: 3083 scaledBlue: 4079); at: 162 put: (ColorValue scaledRed: 3597 scaledGreen: 3565 scaledBlue: 4079); at: 163 put: (ColorValue scaledRed: 3565 scaledGreen: 3565 scaledBlue: 4111); at: 164 put: (ColorValue scaledRed: 4079 scaledGreen: 3565 scaledBlue: 3597); at: 165 put: (ColorValue scaledRed: 3051 scaledGreen: 3597 scaledBlue: 4593); at: 166 put: (ColorValue scaledRed: 6135 scaledGreen: 6135 scaledBlue: 7163); at: 167 put: (ColorValue scaledRed: 4111 scaledGreen: 5107 scaledBlue: 6135); at: 168 put: (ColorValue scaledRed: 3597 scaledGreen: 5107 scaledBlue: 6649); at: 169 put: (ColorValue scaledRed: 3565 scaledGreen: 5139 scaledBlue: 6649); at: 170 put: (ColorValue scaledRed: 3597 scaledGreen: 3565 scaledBlue: 4111); at: 171 put: (ColorValue scaledRed: 4111 scaledGreen: 3083 scaledBlue: 4079); at: 172 put: (ColorValue scaledRed: 3051 scaledGreen: 3597 scaledBlue: 4625); at: 173 put: (ColorValue scaledRed: 2569 scaledGreen: 2055 scaledBlue: 2569); at: 174 put: (ColorValue scaledRed: 3083 scaledGreen: 2055 scaledBlue: 2055); at: 175 put: (ColorValue scaledRed: 2055 scaledGreen: 2569 scaledBlue: 2569); at: 176 put: (ColorValue scaledRed: 3083 scaledGreen: 3565 scaledBlue: 4625); at: 177 put: (ColorValue scaledRed: 3597 scaledGreen: 3597 scaledBlue: 4079); at: 178 put: (ColorValue scaledRed: 3565 scaledGreen: 5107 scaledBlue: 6681); at: 179 put: (ColorValue scaledRed: 4079 scaledGreen: 5107 scaledBlue: 6167); at: 180 put: (ColorValue scaledRed: 4079 scaledGreen: 5139 scaledBlue: 6135); at: 181 put: (ColorValue scaledRed: 5621 scaledGreen: 4593 scaledBlue: 5139); at: 182 put: (ColorValue scaledRed: 5621 scaledGreen: 4625 scaledBlue: 5107); at: 183 put: (ColorValue scaledRed: 4593 scaledGreen: 5107 scaledBlue: 5653); at: 184 put: (ColorValue scaledRed: 4593 scaledGreen: 4625 scaledBlue: 6135); at: 185 put: (ColorValue scaledRed: 5621 scaledGreen: 5107 scaledBlue: 4625); at: 186 put: (ColorValue scaledRed: 5653 scaledGreen: 6649 scaledBlue: 7163); at: 187 put: (ColorValue scaledRed: 7163 scaledGreen: 6135 scaledBlue: 6167); at: 188 put: (ColorValue scaledRed: 6135 scaledGreen: 6649 scaledBlue: 6681); at: 189 put: (ColorValue scaledRed: 3597 scaledGreen: 5139 scaledBlue: 6649); at: 190 put: (ColorValue scaledRed: 3565 scaledGreen: 5139 scaledBlue: 6681); at: 191 put: (ColorValue scaledRed: 4111 scaledGreen: 5139 scaledBlue: 6135); at: 192 put: (ColorValue scaledRed: 3083 scaledGreen: 3597 scaledBlue: 4625); at: 193 put: (ColorValue scaledRed: 3597 scaledGreen: 3597 scaledBlue: 4111); at: 194 put: (ColorValue scaledRed: 5621 scaledGreen: 5139 scaledBlue: 4625); at: 195 put: (ColorValue scaledRed: 4111 scaledGreen: 5107 scaledBlue: 6167); at: 196 put: (ColorValue scaledRed: 3597 scaledGreen: 5107 scaledBlue: 6681); at: 197 put: (ColorValue scaledRed: 5653 scaledGreen: 4593 scaledBlue: 5139); at: 198 put: (ColorValue scaledRed: 4593 scaledGreen: 5139 scaledBlue: 5653); at: 199 put: (ColorValue scaledRed: 6167 scaledGreen: 6135 scaledBlue: 7163); at: 200 put: (ColorValue scaledRed: 4625 scaledGreen: 5107 scaledBlue: 5653); at: 201 put: (ColorValue scaledRed: 5107 scaledGreen: 4625 scaledBlue: 5653); at: 202 put: (ColorValue scaledRed: 8191 scaledGreen: 7709 scaledBlue: 7677); at: 203 put: (ColorValue scaledRed: 5653 scaledGreen: 6681 scaledBlue: 7163); at: 204 put: (ColorValue scaledRed: 2023 scaledGreen: 1509 scaledBlue: 995); at: 205 put: (ColorValue scaledRed: 1509 scaledGreen: 1509 scaledBlue: 1509); at: 206 put: (ColorValue scaledRed: 3597 scaledGreen: 5139 scaledBlue: 6681); at: 207 put: (ColorValue scaledRed: 5653 scaledGreen: 4625 scaledBlue: 5139); at: 208 put: (ColorValue scaledRed: 6167 scaledGreen: 4111 scaledBlue: 5139); at: 209 put: (ColorValue scaledRed: 6135 scaledGreen: 6681 scaledBlue: 6681); at: 210 put: (ColorValue scaledRed: 7195 scaledGreen: 6135 scaledBlue: 6167); at: 211 put: (ColorValue scaledRed: 6167 scaledGreen: 6167 scaledBlue: 7163); at: 212 put: (ColorValue scaledRed: 5653 scaledGreen: 6649 scaledBlue: 7195); at: 213 put: (ColorValue scaledRed: 8191 scaledGreen: 7709 scaledBlue: 7709); at: 214 put: (ColorValue scaledRed: 3051 scaledGreen: 2537 scaledBlue: 3051); at: 215 put: (ColorValue scaledRed: 4079 scaledGreen: 2537 scaledBlue: 2023); at: 216 put: (ColorValue scaledRed: 6681 scaledGreen: 6167 scaledBlue: 6681); at: 217 put: (ColorValue scaledRed: 1541 scaledGreen: 1509 scaledBlue: 1509); at: 218 put: (ColorValue scaledRed: 2023 scaledGreen: 1541 scaledBlue: 995); at: 219 put: (ColorValue scaledRed: 1509 scaledGreen: 1509 scaledBlue: 1541); at: 220 put: (ColorValue scaledRed: 1027 scaledGreen: 1509 scaledBlue: 2023); at: 221 put: (ColorValue scaledRed: 4079 scaledGreen: 4079 scaledBlue: 4593); at: 222 put: (ColorValue scaledRed: 3565 scaledGreen: 4079 scaledBlue: 5107); at: 223 put: (ColorValue scaledRed: 3051 scaledGreen: 2537 scaledBlue: 3083); at: 224 put: (ColorValue scaledRed: 2537 scaledGreen: 3051 scaledBlue: 3083); at: 225 put: (ColorValue scaledRed: 3051 scaledGreen: 2569 scaledBlue: 3051); at: 226 put: (ColorValue scaledRed: 2055 scaledGreen: 1509 scaledBlue: 1027); at: 227 put: (ColorValue scaledRed: 1541 scaledGreen: 1541 scaledBlue: 1509); at: 228 put: (ColorValue scaledRed: 1541 scaledGreen: 1509 scaledBlue: 1541); at: 229 put: (ColorValue scaledRed: 1027 scaledGreen: 1509 scaledBlue: 2055); at: 230 put: (ColorValue scaledRed: 1027 scaledGreen: 1541 scaledBlue: 2023); at: 231 put: (ColorValue scaledRed: 2537 scaledGreen: 2569 scaledBlue: 3565); at: 232 put: (ColorValue scaledRed: 2023 scaledGreen: 1541 scaledBlue: 1027); at: 233 put: (ColorValue scaledRed: 2055 scaledGreen: 1541 scaledBlue: 995); at: 234 put: (ColorValue scaledRed: 4079 scaledGreen: 5621 scaledBlue: 7163); at: 235 put: (ColorValue scaledRed: 5107 scaledGreen: 5621 scaledBlue: 6135); at: 236 put: (ColorValue scaledRed: 3565 scaledGreen: 4111 scaledBlue: 5107); at: 237 put: (ColorValue scaledRed: 3083 scaledGreen: 4079 scaledBlue: 5621); at: 238 put: (ColorValue scaledRed: 5621 scaledGreen: 3565 scaledBlue: 3597); at: 239 put: (ColorValue scaledRed: 3051 scaledGreen: 2569 scaledBlue: 3083); at: 240 put: (ColorValue scaledRed: 4079 scaledGreen: 2055 scaledBlue: 2569); at: 241 put: (ColorValue scaledRed: 3565 scaledGreen: 2569 scaledBlue: 2569); at: 242 put: (ColorValue scaledRed: 2055 scaledGreen: 1541 scaledBlue: 1027); at: 243 put: (ColorValue scaledRed: 1541 scaledGreen: 1541 scaledBlue: 1541); at: 244 put: (ColorValue scaledRed: 3083 scaledGreen: 2569 scaledBlue: 3051); at: 245 put: (ColorValue scaledRed: 2569 scaledGreen: 2569 scaledBlue: 3565); at: 246 put: (ColorValue scaledRed: 4079 scaledGreen: 3597 scaledBlue: 5107); at: 247 put: (ColorValue scaledRed: 4593 scaledGreen: 3597 scaledBlue: 4593); at: 248 put: (ColorValue scaledRed: 4079 scaledGreen: 4079 scaledBlue: 4625); at: 249 put: (ColorValue scaledRed: 4593 scaledGreen: 4079 scaledBlue: 4111); at: 250 put: (ColorValue scaledRed: 3597 scaledGreen: 4079 scaledBlue: 5107); at: 251 put: (ColorValue scaledRed: 4079 scaledGreen: 5653 scaledBlue: 7163); at: 252 put: (ColorValue scaledRed: 4625 scaledGreen: 5621 scaledBlue: 6649); at: 253 put: (ColorValue scaledRed: 5107 scaledGreen: 5653 scaledBlue: 6135); at: 254 put: (ColorValue scaledRed: 3565 scaledGreen: 4111 scaledBlue: 5139); at: 255 put: (ColorValue scaledRed: 3051 scaledGreen: 4111 scaledBlue: 5653); at: 256 put: (ColorValue scaledRed: 3083 scaledGreen: 4079 scaledBlue: 5653); at: 257 put: (ColorValue scaledRed: 4593 scaledGreen: 3597 scaledBlue: 4625); at: 258 put: (ColorValue scaledRed: 5653 scaledGreen: 3565 scaledBlue: 3597); at: 259 put: (ColorValue scaledRed: 4111 scaledGreen: 4079 scaledBlue: 4625); at: 260 put: (ColorValue scaledRed: 3597 scaledGreen: 4111 scaledBlue: 5107); at: 261 put: (ColorValue scaledRed: 6135 scaledGreen: 5107 scaledBlue: 5653); at: 262 put: (ColorValue scaledRed: 3083 scaledGreen: 2569 scaledBlue: 3083); at: 263 put: (ColorValue scaledRed: 5107 scaledGreen: 5139 scaledBlue: 6649); at: 264 put: (ColorValue scaledRed: 2569 scaledGreen: 4111 scaledBlue: 6135); at: 265 put: (ColorValue scaledRed: 3597 scaledGreen: 2569 scaledBlue: 2569); at: 266 put: (ColorValue scaledRed: 6167 scaledGreen: 7163 scaledBlue: 7677); at: 267 put: (ColorValue scaledRed: 6649 scaledGreen: 7163 scaledBlue: 7195); at: 268 put: (ColorValue scaledRed: 5107 scaledGreen: 5139 scaledBlue: 6681); at: 269 put: (ColorValue scaledRed: 5139 scaledGreen: 5621 scaledBlue: 6167); at: 270 put: (ColorValue scaledRed: 4625 scaledGreen: 5653 scaledBlue: 6649); at: 271 put: (ColorValue scaledRed: 4625 scaledGreen: 5621 scaledBlue: 6681); at: 272 put: (ColorValue scaledRed: 5107 scaledGreen: 5653 scaledBlue: 6167); at: 273 put: (ColorValue scaledRed: 6681 scaledGreen: 7163 scaledBlue: 7195); at: 274 put: (ColorValue scaledRed: 6167 scaledGreen: 7195 scaledBlue: 7677); at: 275 put: (ColorValue scaledRed: 2023 scaledGreen: 2023 scaledBlue: 2023); at: 276 put: (ColorValue scaledRed: 4625 scaledGreen: 5653 scaledBlue: 6681); at: 277 put: (ColorValue scaledRed: 5139 scaledGreen: 5653 scaledBlue: 6167); at: 278 put: (ColorValue scaledRed: 6167 scaledGreen: 5139 scaledBlue: 5653); at: 279 put: (ColorValue scaledRed: 481 scaledGreen: 513 scaledBlue: 995); at: 280 put: (ColorValue scaledRed: 2537 scaledGreen: 3051 scaledBlue: 4593); at: 281 put: (ColorValue scaledRed: 3565 scaledGreen: 3051 scaledBlue: 3565); at: 282 put: (ColorValue scaledRed: 6681 scaledGreen: 7195 scaledBlue: 7195); at: 283 put: (ColorValue scaledRed: 2055 scaledGreen: 2023 scaledBlue: 2023); at: 284 put: (ColorValue scaledRed: 1509 scaledGreen: 2023 scaledBlue: 2569); at: 285 put: (ColorValue scaledRed: 1509 scaledGreen: 2055 scaledBlue: 2537); at: 286 put: (ColorValue scaledRed: 1027 scaledGreen: 513 scaledBlue: 481); at: 287 put: (ColorValue scaledRed: 513 scaledGreen: 995 scaledBlue: 513); at: 288 put: (ColorValue scaledRed: 513 scaledGreen: 513 scaledBlue: 995); at: 289 put: (ColorValue scaledRed: 1541 scaledGreen: 2023 scaledBlue: 2537); at: 290 put: (ColorValue scaledRed: 2537 scaledGreen: 2023 scaledBlue: 1541); at: 291 put: (ColorValue scaledRed: 2023 scaledGreen: 2023 scaledBlue: 2055); at: 292 put: (ColorValue scaledRed: 2569 scaledGreen: 2023 scaledBlue: 1509); at: 293 put: (ColorValue scaledRed: 4079 scaledGreen: 4593 scaledBlue: 5621); at: 294 put: (ColorValue scaledRed: 3565 scaledGreen: 4593 scaledBlue: 6135); at: 295 put: (ColorValue scaledRed: 2537 scaledGreen: 3565 scaledBlue: 4111); at: 296 put: (ColorValue scaledRed: 4111 scaledGreen: 3051 scaledBlue: 3051); at: 297 put: (ColorValue scaledRed: 3565 scaledGreen: 3051 scaledBlue: 3597); at: 298 put: (ColorValue scaledRed: 2537 scaledGreen: 2055 scaledBlue: 1541); at: 299 put: (ColorValue scaledRed: 2569 scaledGreen: 2055 scaledBlue: 1509); at: 300 put: (ColorValue scaledRed: 2055 scaledGreen: 2023 scaledBlue: 2055); at: 301 put: (ColorValue scaledRed: 513 scaledGreen: 513 scaledBlue: 1027); at: 302 put: (ColorValue scaledRed: 3051 scaledGreen: 1541 scaledBlue: 1541); at: 303 put: (ColorValue scaledRed: 1509 scaledGreen: 2055 scaledBlue: 2569); at: 304 put: (ColorValue scaledRed: 3565 scaledGreen: 3083 scaledBlue: 3565); at: 305 put: (ColorValue scaledRed: 1541 scaledGreen: 2023 scaledBlue: 2569); at: 306 put: (ColorValue scaledRed: 2569 scaledGreen: 2023 scaledBlue: 1541); at: 307 put: (ColorValue scaledRed: 5621 scaledGreen: 6135 scaledBlue: 6649); at: 308 put: (ColorValue scaledRed: 4079 scaledGreen: 4593 scaledBlue: 5653); at: 309 put: (ColorValue scaledRed: 3565 scaledGreen: 4625 scaledBlue: 6135); at: 310 put: (ColorValue scaledRed: 3565 scaledGreen: 4593 scaledBlue: 6167); at: 311 put: (ColorValue scaledRed: 3597 scaledGreen: 3051 scaledBlue: 3597); at: 312 put: (ColorValue scaledRed: 3565 scaledGreen: 3083 scaledBlue: 3597); at: 313 put: (ColorValue scaledRed: 4625 scaledGreen: 2537 scaledBlue: 3083); at: 314 put: (ColorValue scaledRed: 2055 scaledGreen: 2055 scaledBlue: 2055); at: 315 put: (ColorValue scaledRed: 3083 scaledGreen: 3083 scaledBlue: 4079); at: 316 put: (ColorValue scaledRed: 3597 scaledGreen: 4593 scaledBlue: 6135); at: 317 put: (ColorValue scaledRed: 4111 scaledGreen: 4593 scaledBlue: 5621); at: 318 put: (ColorValue scaledRed: 5107 scaledGreen: 4111 scaledBlue: 5107); at: 319 put: (ColorValue scaledRed: 3597 scaledGreen: 5107 scaledBlue: 5621); at: 320 put: (ColorValue scaledRed: 4079 scaledGreen: 4625 scaledBlue: 5621); at: 321 put: (ColorValue scaledRed: 3051 scaledGreen: 4625 scaledBlue: 6649); at: 322 put: (ColorValue scaledRed: 2055 scaledGreen: 3565 scaledBlue: 4625); at: 323 put: (ColorValue scaledRed: 4079 scaledGreen: 3083 scaledBlue: 3083); at: 324 put: (ColorValue scaledRed: 2569 scaledGreen: 2055 scaledBlue: 1541); at: 325 put: (ColorValue scaledRed: 3597 scaledGreen: 3083 scaledBlue: 3565); at: 326 put: (ColorValue scaledRed: 7163 scaledGreen: 7677 scaledBlue: 7677); at: 327 put: (ColorValue scaledRed: 5621 scaledGreen: 5653 scaledBlue: 7163); at: 328 put: (ColorValue scaledRed: 6135 scaledGreen: 5653 scaledBlue: 6649); at: 329 put: (ColorValue scaledRed: 5139 scaledGreen: 6649 scaledBlue: 6649); at: 330 put: (ColorValue scaledRed: 3565 scaledGreen: 4625 scaledBlue: 6167); at: 331 put: (ColorValue scaledRed: 5139 scaledGreen: 4111 scaledBlue: 5107); at: 332 put: (ColorValue scaledRed: 4111 scaledGreen: 5107 scaledBlue: 5139); at: 333 put: (ColorValue scaledRed: 3083 scaledGreen: 5107 scaledBlue: 6167); at: 334 put: (ColorValue scaledRed: 3083 scaledGreen: 4625 scaledBlue: 6649); at: 335 put: (ColorValue scaledRed: 4079 scaledGreen: 4625 scaledBlue: 5653); at: 336 put: (ColorValue scaledRed: 4111 scaledGreen: 4625 scaledBlue: 5621); at: 337 put: (ColorValue scaledRed: 4625 scaledGreen: 4593 scaledBlue: 5139); at: 338 put: (ColorValue scaledRed: 5621 scaledGreen: 6135 scaledBlue: 6681); at: 339 put: (ColorValue scaledRed: 3083 scaledGreen: 3083 scaledBlue: 4111); at: 340 put: (ColorValue scaledRed: 7163 scaledGreen: 7677 scaledBlue: 7709); at: 341 put: (ColorValue scaledRed: 6135 scaledGreen: 5653 scaledBlue: 6681); at: 342 put: (ColorValue scaledRed: 995 scaledGreen: 995 scaledBlue: 1509); at: 343 put: (ColorValue scaledRed: 5653 scaledGreen: 6135 scaledBlue: 6681); at: 344 put: (ColorValue scaledRed: 4111 scaledGreen: 4625 scaledBlue: 5653); at: 345 put: (ColorValue scaledRed: 3597 scaledGreen: 4625 scaledBlue: 6167); at: 346 put: (ColorValue scaledRed: 5621 scaledGreen: 6167 scaledBlue: 6681); at: 347 put: (ColorValue scaledRed: 5139 scaledGreen: 6135 scaledBlue: 7195); at: 348 put: (ColorValue scaledRed: 7195 scaledGreen: 7709 scaledBlue: 7677); at: 349 put: (ColorValue scaledRed: 2023 scaledGreen: 2537 scaledBlue: 3051); at: 350 put: (ColorValue scaledRed: 5653 scaledGreen: 6167 scaledBlue: 6681); at: 351 put: (ColorValue scaledRed: 1509 scaledGreen: 1027 scaledBlue: 995); at: 352 put: (ColorValue scaledRed: 995 scaledGreen: 1027 scaledBlue: 1509); at: 353 put: (ColorValue scaledRed: 4079 scaledGreen: 3565 scaledBlue: 4079); at: 354 put: (ColorValue scaledRed: 3565 scaledGreen: 3565 scaledBlue: 4593); at: 355 put: (ColorValue scaledRed: 2537 scaledGreen: 2537 scaledBlue: 2569); at: 356 put: (ColorValue scaledRed: 2023 scaledGreen: 2537 scaledBlue: 3083); at: 357 put: (ColorValue scaledRed: 2055 scaledGreen: 2537 scaledBlue: 3051); at: 358 put: (ColorValue scaledRed: 2023 scaledGreen: 1027 scaledBlue: 513); at: 359 put: (ColorValue scaledRed: 1509 scaledGreen: 1027 scaledBlue: 1027); at: 360 put: (ColorValue scaledRed: 1541 scaledGreen: 1027 scaledBlue: 995); at: 361 put: (ColorValue scaledRed: 995 scaledGreen: 1027 scaledBlue: 1541); at: 362 put: (ColorValue scaledRed: 2569 scaledGreen: 2537 scaledBlue: 2537); at: 363 put: (ColorValue scaledRed: 3565 scaledGreen: 2055 scaledBlue: 2023); at: 364 put: (ColorValue scaledRed: 1027 scaledGreen: 1509 scaledBlue: 1027); at: 365 put: (ColorValue scaledRed: 4593 scaledGreen: 5107 scaledBlue: 6135); at: 366 put: (ColorValue scaledRed: 4079 scaledGreen: 5107 scaledBlue: 6649); at: 367 put: (ColorValue scaledRed: 5107 scaledGreen: 5107 scaledBlue: 5621); at: 368 put: (ColorValue scaledRed: 5107 scaledGreen: 3083 scaledBlue: 3565); at: 369 put: (ColorValue scaledRed: 3597 scaledGreen: 3565 scaledBlue: 4593); at: 370 put: (ColorValue scaledRed: 4079 scaledGreen: 3565 scaledBlue: 4111); at: 371 put: (ColorValue scaledRed: 3083 scaledGreen: 2569 scaledBlue: 2023); at: 372 put: (ColorValue scaledRed: 3565 scaledGreen: 2055 scaledBlue: 2055); at: 373 put: (ColorValue scaledRed: 2569 scaledGreen: 2537 scaledBlue: 2569); at: 374 put: (ColorValue scaledRed: 1541 scaledGreen: 1027 scaledBlue: 1027); at: 375 put: (ColorValue scaledRed: 1027 scaledGreen: 1027 scaledBlue: 1541); at: 376 put: (ColorValue scaledRed: 3597 scaledGreen: 2023 scaledBlue: 2055); at: 377 put: (ColorValue scaledRed: 2055 scaledGreen: 2537 scaledBlue: 3083); at: 378 put: (ColorValue scaledRed: 4111 scaledGreen: 3565 scaledBlue: 4079); at: 379 put: (ColorValue scaledRed: 4593 scaledGreen: 3083 scaledBlue: 4079); at: 380 put: (ColorValue scaledRed: 3565 scaledGreen: 4079 scaledBlue: 4111); at: 381 put: (ColorValue scaledRed: 7163 scaledGreen: 6135 scaledBlue: 6649); at: 382 put: (ColorValue scaledRed: 6135 scaledGreen: 6649 scaledBlue: 7163); at: 383 put: (ColorValue scaledRed: 6649 scaledGreen: 6649 scaledBlue: 6649); at: 384 put: (ColorValue scaledRed: 3597 scaledGreen: 5621 scaledBlue: 6649); at: 385 put: (ColorValue scaledRed: 4593 scaledGreen: 5107 scaledBlue: 6167); at: 386 put: (ColorValue scaledRed: 4079 scaledGreen: 5139 scaledBlue: 6649); at: 387 put: (ColorValue scaledRed: 3051 scaledGreen: 3597 scaledBlue: 5139); at: 388 put: (ColorValue scaledRed: 4111 scaledGreen: 3565 scaledBlue: 4111); at: 389 put: (ColorValue scaledRed: 3597 scaledGreen: 3597 scaledBlue: 4593); at: 390 put: (ColorValue scaledRed: 3083 scaledGreen: 4079 scaledBlue: 4625); at: 391 put: (ColorValue scaledRed: 3565 scaledGreen: 3597 scaledBlue: 4625); at: 392 put: (ColorValue scaledRed: 4111 scaledGreen: 5107 scaledBlue: 6649); at: 393 put: (ColorValue scaledRed: 4593 scaledGreen: 5139 scaledBlue: 6135); at: 394 put: (ColorValue scaledRed: 5139 scaledGreen: 5107 scaledBlue: 5621); at: 395 put: (ColorValue scaledRed: 4593 scaledGreen: 5621 scaledBlue: 5653); at: 396 put: (ColorValue scaledRed: 3565 scaledGreen: 5139 scaledBlue: 7163); at: 397 put: (ColorValue scaledRed: 4079 scaledGreen: 3597 scaledBlue: 4111); at: 398 put: (ColorValue scaledRed: 4625 scaledGreen: 5107 scaledBlue: 6135); at: 399 put: (ColorValue scaledRed: 7195 scaledGreen: 6135 scaledBlue: 6649); at: 400 put: (ColorValue scaledRed: 6649 scaledGreen: 6167 scaledBlue: 7163); at: 401 put: (ColorValue scaledRed: 6135 scaledGreen: 6681 scaledBlue: 7163); at: 402 put: (ColorValue scaledRed: 4079 scaledGreen: 5139 scaledBlue: 6681); at: 403 put: (ColorValue scaledRed: 3597 scaledGreen: 5621 scaledBlue: 6681); at: 404 put: (ColorValue scaledRed: 3597 scaledGreen: 5139 scaledBlue: 7163); at: 405 put: (ColorValue scaledRed: 3083 scaledGreen: 4111 scaledBlue: 4625); at: 406 put: (ColorValue scaledRed: 4111 scaledGreen: 3597 scaledBlue: 4111); at: 407 put: (ColorValue scaledRed: 4111 scaledGreen: 5139 scaledBlue: 6649); at: 408 put: (ColorValue scaledRed: 4625 scaledGreen: 5139 scaledBlue: 6135); at: 409 put: (ColorValue scaledRed: 5139 scaledGreen: 5107 scaledBlue: 5653); at: 410 put: (ColorValue scaledRed: 4625 scaledGreen: 5107 scaledBlue: 6167); at: 411 put: (ColorValue scaledRed: 6167 scaledGreen: 6649 scaledBlue: 7163); at: 412 put: (ColorValue scaledRed: 6135 scaledGreen: 6167 scaledBlue: 7677); at: 413 put: (ColorValue scaledRed: 6135 scaledGreen: 6681 scaledBlue: 7195); at: 414 put: (ColorValue scaledRed: 2023 scaledGreen: 1509 scaledBlue: 1509); at: 415 put: (ColorValue scaledRed: 6167 scaledGreen: 6681 scaledBlue: 7163); at: 416 put: (ColorValue scaledRed: 4111 scaledGreen: 5139 scaledBlue: 6681); at: 417 put: (ColorValue scaledRed: 5653 scaledGreen: 7163 scaledBlue: 7195); at: 418 put: (ColorValue scaledRed: 481 scaledGreen: 481 scaledBlue: 0); at: 419 put: (ColorValue scaledRed: 3565 scaledGreen: 2537 scaledBlue: 3051); at: 420 put: (ColorValue scaledRed: 3051 scaledGreen: 3051 scaledBlue: 3051); at: 421 put: (ColorValue scaledRed: 2537 scaledGreen: 3051 scaledBlue: 3565); at: 422 put: (ColorValue scaledRed: 2023 scaledGreen: 1541 scaledBlue: 1509); at: 423 put: (ColorValue scaledRed: 1509 scaledGreen: 1541 scaledBlue: 2023); at: 424 put: (ColorValue scaledRed: 1541 scaledGreen: 1509 scaledBlue: 2023); at: 425 put: (ColorValue scaledRed: 6167 scaledGreen: 6681 scaledBlue: 7195); at: 426 put: (ColorValue scaledRed: 4593 scaledGreen: 4079 scaledBlue: 4593); at: 427 put: (ColorValue scaledRed: 4079 scaledGreen: 4079 scaledBlue: 5107); at: 428 put: (ColorValue scaledRed: 4079 scaledGreen: 2537 scaledBlue: 2569); at: 429 put: (ColorValue scaledRed: 4079 scaledGreen: 2569 scaledBlue: 2537); at: 430 put: (ColorValue scaledRed: 4111 scaledGreen: 2537 scaledBlue: 2537); at: 431 put: (ColorValue scaledRed: 2055 scaledGreen: 1541 scaledBlue: 1509); at: 432 put: (ColorValue scaledRed: 1541 scaledGreen: 1541 scaledBlue: 2023); at: 433 put: (ColorValue scaledRed: 2569 scaledGreen: 1509 scaledBlue: 1027); at: 434 put: (ColorValue scaledRed: 2023 scaledGreen: 1541 scaledBlue: 1541); at: 435 put: (ColorValue scaledRed: 1509 scaledGreen: 1541 scaledBlue: 2055); at: 436 put: (ColorValue scaledRed: 3051 scaledGreen: 2569 scaledBlue: 3565); at: 437 put: (ColorValue scaledRed: 2569 scaledGreen: 3051 scaledBlue: 3565); at: 438 put: (ColorValue scaledRed: 2023 scaledGreen: 3051 scaledBlue: 4111); at: 439 put: (ColorValue scaledRed: 2537 scaledGreen: 2569 scaledBlue: 4079); at: 440 put: (ColorValue scaledRed: 3083 scaledGreen: 3051 scaledBlue: 3051); at: 441 put: (ColorValue scaledRed: 5107 scaledGreen: 5621 scaledBlue: 6649); at: 442 put: (ColorValue scaledRed: 5621 scaledGreen: 5621 scaledBlue: 6135); at: 443 put: (ColorValue scaledRed: 3565 scaledGreen: 4111 scaledBlue: 5621); at: 444 put: (ColorValue scaledRed: 3565 scaledGreen: 4079 scaledBlue: 5653); at: 445 put: (ColorValue scaledRed: 3083 scaledGreen: 4593 scaledBlue: 5621); at: 446 put: (ColorValue scaledRed: 2055 scaledGreen: 3051 scaledBlue: 4111); at: 447 put: (ColorValue scaledRed: 3083 scaledGreen: 2569 scaledBlue: 3565); at: 448 put: (ColorValue scaledRed: 2569 scaledGreen: 3083 scaledBlue: 3565); at: 449 put: (ColorValue scaledRed: 2055 scaledGreen: 1541 scaledBlue: 1541); at: 450 put: (ColorValue scaledRed: 1541 scaledGreen: 1541 scaledBlue: 2055); at: 451 put: (ColorValue scaledRed: 3083 scaledGreen: 3083 scaledBlue: 3051); at: 452 put: (ColorValue scaledRed: 2537 scaledGreen: 3083 scaledBlue: 3597); at: 453 put: (ColorValue scaledRed: 2569 scaledGreen: 3051 scaledBlue: 3597); at: 454 put: (ColorValue scaledRed: 4593 scaledGreen: 4079 scaledBlue: 4625); at: 455 put: (ColorValue scaledRed: 4625 scaledGreen: 4079 scaledBlue: 4593); at: 456 put: (ColorValue scaledRed: 5621 scaledGreen: 3565 scaledBlue: 4111); at: 457 put: (ColorValue scaledRed: 4111 scaledGreen: 4079 scaledBlue: 5107); at: 458 put: (ColorValue scaledRed: 3597 scaledGreen: 4593 scaledBlue: 5107); at: 459 put: (ColorValue scaledRed: 3565 scaledGreen: 4593 scaledBlue: 5139); at: 460 put: (ColorValue scaledRed: 5107 scaledGreen: 3597 scaledBlue: 4593); at: 461 put: (ColorValue scaledRed: 4079 scaledGreen: 4593 scaledBlue: 4625); at: 462 put: (ColorValue scaledRed: 4079 scaledGreen: 4625 scaledBlue: 4593); at: 463 put: (ColorValue scaledRed: 4079 scaledGreen: 4079 scaledBlue: 5139); at: 464 put: (ColorValue scaledRed: 3597 scaledGreen: 3051 scaledBlue: 2569); at: 465 put: (ColorValue scaledRed: 3051 scaledGreen: 4111 scaledBlue: 6135); at: 466 put: (ColorValue scaledRed: 4111 scaledGreen: 3051 scaledBlue: 2055); at: 467 put: (ColorValue scaledRed: 6649 scaledGreen: 7163 scaledBlue: 7677); at: 468 put: (ColorValue scaledRed: 5139 scaledGreen: 5621 scaledBlue: 6649); at: 469 put: (ColorValue scaledRed: 5107 scaledGreen: 5621 scaledBlue: 6681); at: 470 put: (ColorValue scaledRed: 5107 scaledGreen: 6135 scaledBlue: 6167); at: 471 put: (ColorValue scaledRed: 3597 scaledGreen: 4111 scaledBlue: 5621); at: 472 put: (ColorValue scaledRed: 4593 scaledGreen: 4111 scaledBlue: 4625); at: 473 put: (ColorValue scaledRed: 3083 scaledGreen: 4593 scaledBlue: 5653); at: 474 put: (ColorValue scaledRed: 2569 scaledGreen: 3083 scaledBlue: 3597); at: 475 put: (ColorValue scaledRed: 2055 scaledGreen: 3083 scaledBlue: 4111); at: 476 put: (ColorValue scaledRed: 4625 scaledGreen: 4079 scaledBlue: 4625); at: 477 put: (ColorValue scaledRed: 4079 scaledGreen: 4111 scaledBlue: 5139); at: 478 put: (ColorValue scaledRed: 4625 scaledGreen: 6135 scaledBlue: 6649); at: 479 put: (ColorValue scaledRed: 4625 scaledGreen: 5621 scaledBlue: 7163); at: 480 put: (ColorValue scaledRed: 5107 scaledGreen: 5653 scaledBlue: 6649); at: 481 put: (ColorValue scaledRed: 5621 scaledGreen: 5139 scaledBlue: 6649); at: 482 put: (ColorValue scaledRed: 4111 scaledGreen: 4111 scaledBlue: 5107); at: 483 put: (ColorValue scaledRed: 4111 scaledGreen: 4593 scaledBlue: 4625); at: 484 put: (ColorValue scaledRed: 6649 scaledGreen: 7195 scaledBlue: 7677); at: 485 put: (ColorValue scaledRed: 6681 scaledGreen: 7163 scaledBlue: 7677); at: 486 put: (ColorValue scaledRed: 7709 scaledGreen: 7163 scaledBlue: 6649); at: 487 put: (ColorValue scaledRed: 5139 scaledGreen: 5653 scaledBlue: 6649); at: 488 put: (ColorValue scaledRed: 5107 scaledGreen: 5653 scaledBlue: 6681); at: 489 put: (ColorValue scaledRed: 6167 scaledGreen: 5139 scaledBlue: 6135); at: 490 put: (ColorValue scaledRed: 3597 scaledGreen: 4111 scaledBlue: 5653); at: 491 put: (ColorValue scaledRed: 4111 scaledGreen: 4111 scaledBlue: 5139); at: 492 put: (ColorValue scaledRed: 4625 scaledGreen: 4111 scaledBlue: 4625); at: 493 put: (ColorValue scaledRed: 5139 scaledGreen: 5621 scaledBlue: 6681); at: 494 put: (ColorValue scaledRed: 5653 scaledGreen: 5621 scaledBlue: 6167); at: 495 put: (ColorValue scaledRed: 6681 scaledGreen: 7195 scaledBlue: 7677); at: 496 put: (ColorValue scaledRed: 7163 scaledGreen: 7195 scaledBlue: 7195); at: 497 put: (ColorValue scaledRed: 2023 scaledGreen: 2023 scaledBlue: 2537); at: 498 put: (ColorValue scaledRed: 5139 scaledGreen: 5653 scaledBlue: 6681); at: 499 put: (ColorValue scaledRed: 1509 scaledGreen: 513 scaledBlue: 481); at: 500 put: (ColorValue scaledRed: 995 scaledGreen: 995 scaledBlue: 513); at: 501 put: (ColorValue scaledRed: 513 scaledGreen: 995 scaledBlue: 995); at: 502 put: (ColorValue scaledRed: 1027 scaledGreen: 995 scaledBlue: 481); at: 503 put: (ColorValue scaledRed: 995 scaledGreen: 513 scaledBlue: 995); at: 504 put: (ColorValue scaledRed: 2537 scaledGreen: 2023 scaledBlue: 2023); at: 505 put: (ColorValue scaledRed: 4079 scaledGreen: 3565 scaledBlue: 3051); at: 506 put: (ColorValue scaledRed: 2537 scaledGreen: 3565 scaledBlue: 4593); at: 507 put: (ColorValue scaledRed: 2537 scaledGreen: 2023 scaledBlue: 2055); at: 508 put: (ColorValue scaledRed: 2055 scaledGreen: 2023 scaledBlue: 2537); at: 509 put: (ColorValue scaledRed: 1541 scaledGreen: 2023 scaledBlue: 3051); at: 510 put: (ColorValue scaledRed: 1027 scaledGreen: 995 scaledBlue: 513); at: 511 put: (ColorValue scaledRed: 513 scaledGreen: 995 scaledBlue: 1027); at: 512 put: (ColorValue scaledRed: 3051 scaledGreen: 2023 scaledBlue: 1541); at: 513 put: (ColorValue scaledRed: 2569 scaledGreen: 2023 scaledBlue: 2023); at: 514 put: (ColorValue scaledRed: 4593 scaledGreen: 4593 scaledBlue: 5621); at: 515 put: (ColorValue scaledRed: 4079 scaledGreen: 4593 scaledBlue: 6135); at: 516 put: (ColorValue scaledRed: 3565 scaledGreen: 3083 scaledBlue: 4079); at: 517 put: (ColorValue scaledRed: 2569 scaledGreen: 3565 scaledBlue: 4593); at: 518 put: (ColorValue scaledRed: 3051 scaledGreen: 3565 scaledBlue: 4111); at: 519 put: (ColorValue scaledRed: 2055 scaledGreen: 2055 scaledBlue: 2537); at: 520 put: (ColorValue scaledRed: 1541 scaledGreen: 2055 scaledBlue: 3051); at: 521 put: (ColorValue scaledRed: 2023 scaledGreen: 2055 scaledBlue: 2569); at: 522 put: (ColorValue scaledRed: 3051 scaledGreen: 3083 scaledBlue: 4593); at: 523 put: (ColorValue scaledRed: 2569 scaledGreen: 2055 scaledBlue: 2023); at: 524 put: (ColorValue scaledRed: 6135 scaledGreen: 6135 scaledBlue: 6649); at: 525 put: (ColorValue scaledRed: 5621 scaledGreen: 6135 scaledBlue: 7163); at: 526 put: (ColorValue scaledRed: 6649 scaledGreen: 6135 scaledBlue: 6135); at: 527 put: (ColorValue scaledRed: 5107 scaledGreen: 4625 scaledBlue: 5107); at: 528 put: (ColorValue scaledRed: 3083 scaledGreen: 5107 scaledBlue: 6649); at: 529 put: (ColorValue scaledRed: 3565 scaledGreen: 4625 scaledBlue: 6649); at: 530 put: (ColorValue scaledRed: 4079 scaledGreen: 5107 scaledBlue: 5653); at: 531 put: (ColorValue scaledRed: 3565 scaledGreen: 5107 scaledBlue: 6167); at: 532 put: (ColorValue scaledRed: 4079 scaledGreen: 5139 scaledBlue: 5621); at: 533 put: (ColorValue scaledRed: 2055 scaledGreen: 2055 scaledBlue: 2569); at: 534 put: (ColorValue scaledRed: 1541 scaledGreen: 2055 scaledBlue: 3083); at: 535 put: (ColorValue scaledRed: 2537 scaledGreen: 3597 scaledBlue: 4625); at: 536 put: (ColorValue scaledRed: 3597 scaledGreen: 3083 scaledBlue: 4079); at: 537 put: (ColorValue scaledRed: 3597 scaledGreen: 3565 scaledBlue: 3597); at: 538 put: (ColorValue scaledRed: 3083 scaledGreen: 2055 scaledBlue: 1541); at: 539 put: (ColorValue scaledRed: 2569 scaledGreen: 2055 scaledBlue: 2055); at: 540 put: (ColorValue scaledRed: 4079 scaledGreen: 3083 scaledBlue: 3597); at: 541 put: (ColorValue scaledRed: 6649 scaledGreen: 6167 scaledBlue: 6135); at: 542 put: (ColorValue scaledRed: 5621 scaledGreen: 6167 scaledBlue: 7163); at: 543 put: (ColorValue scaledRed: 5621 scaledGreen: 6649 scaledBlue: 6681); at: 544 put: (ColorValue scaledRed: 4111 scaledGreen: 4625 scaledBlue: 6135); at: 545 put: (ColorValue scaledRed: 4079 scaledGreen: 4625 scaledBlue: 6167); at: 546 put: (ColorValue scaledRed: 4111 scaledGreen: 5107 scaledBlue: 5653); at: 547 put: (ColorValue scaledRed: 3597 scaledGreen: 3083 scaledBlue: 4111); at: 548 put: (ColorValue scaledRed: 3083 scaledGreen: 3597 scaledBlue: 4111); at: 549 put: (ColorValue scaledRed: 3083 scaledGreen: 5139 scaledBlue: 6649); at: 550 put: (ColorValue scaledRed: 5139 scaledGreen: 4593 scaledBlue: 5139); at: 551 put: (ColorValue scaledRed: 3083 scaledGreen: 5107 scaledBlue: 6681); at: 552 put: (ColorValue scaledRed: 6135 scaledGreen: 6135 scaledBlue: 6681); at: 553 put: (ColorValue scaledRed: 5139 scaledGreen: 6649 scaledBlue: 7163); at: 554 put: (ColorValue scaledRed: 5653 scaledGreen: 6135 scaledBlue: 7163); at: 555 put: (ColorValue scaledRed: 4625 scaledGreen: 4593 scaledBlue: 5653); at: 556 put: (ColorValue scaledRed: 5653 scaledGreen: 6649 scaledBlue: 6681); at: 557 put: (ColorValue scaledRed: 7163 scaledGreen: 5653 scaledBlue: 6167); at: 558 put: (ColorValue scaledRed: 5653 scaledGreen: 6135 scaledBlue: 7195); at: 559 put: (ColorValue scaledRed: 3597 scaledGreen: 5139 scaledBlue: 6167); at: 560 put: (ColorValue scaledRed: 4111 scaledGreen: 4625 scaledBlue: 6167); at: 561 put: (ColorValue scaledRed: 4625 scaledGreen: 4625 scaledBlue: 5653); at: 562 put: (ColorValue scaledRed: 4111 scaledGreen: 5139 scaledBlue: 5653); at: 563 put: (ColorValue scaledRed: 3083 scaledGreen: 5139 scaledBlue: 6681); at: 564 put: (ColorValue scaledRed: 7195 scaledGreen: 7709 scaledBlue: 8191); at: 565 put: (ColorValue scaledRed: 2537 scaledGreen: 2537 scaledBlue: 3051); at: 566 put: (ColorValue scaledRed: 2023 scaledGreen: 2537 scaledBlue: 3565); at: 567 put: (ColorValue scaledRed: 3051 scaledGreen: 2537 scaledBlue: 2537); at: 568 put: (ColorValue scaledRed: 995 scaledGreen: 1509 scaledBlue: 1541); at: 569 put: (ColorValue scaledRed: 1509 scaledGreen: 1509 scaledBlue: 1027); at: 570 put: (ColorValue scaledRed: 1509 scaledGreen: 1027 scaledBlue: 1509); at: 571 put: (ColorValue scaledRed: 3565 scaledGreen: 2537 scaledBlue: 2023); at: 572 put: (ColorValue scaledRed: 3051 scaledGreen: 4079 scaledBlue: 5107); at: 573 put: (ColorValue scaledRed: 2055 scaledGreen: 2537 scaledBlue: 3565); at: 574 put: (ColorValue scaledRed: 3051 scaledGreen: 2537 scaledBlue: 2569); at: 575 put: (ColorValue scaledRed: 2569 scaledGreen: 2537 scaledBlue: 3051); at: 576 put: (ColorValue scaledRed: 1027 scaledGreen: 1509 scaledBlue: 1541); at: 577 put: (ColorValue scaledRed: 2055 scaledGreen: 1027 scaledBlue: 995); at: 578 put: (ColorValue scaledRed: 1541 scaledGreen: 1509 scaledBlue: 1027); at: 579 put: (ColorValue scaledRed: 2537 scaledGreen: 2569 scaledBlue: 3051); at: 580 put: (ColorValue scaledRed: 2023 scaledGreen: 2537 scaledBlue: 3597); at: 581 put: (ColorValue scaledRed: 2023 scaledGreen: 2569 scaledBlue: 3565); yourself)) usingBits: (ByteArray fromPackedString: '@L4@K0B&lt;@L4@/@@Y@L4A$PB&lt;@N$@/@FQ@J\@:PB(@L4@/@@Y@J\@FPB&lt;@A$@/@@Y@J @:PBT@L4@%@CM@IP@@@@Y@A$@FPFQ@B&lt;BK @Y@K4A$PB''@K0@/PCM@K0A$PCM@A$@3PCM@L4A$ B&lt;@L4A$PFR@J\@3PB&lt;@YD@*@CM@@@A PC)@YH@FPB&lt;@YD@/@@Y@J @FPCM@A$@/@FA@J @FPFA@A$@)0FR@J\@3PBT@YH@)0CM@A(A40G&amp;@QL@)0@@@XD@/@FQ@L4@3PCM@YD@/@CM@L4@3PCM@YH@3PE?@K4@3PCM@YH@%@CM@K0@3PB(@L4@/@A*@SLB@PD$@X@@@@BT@N$@*@FR@J @F@B&lt;@A$@/@@Y@L4@FPB''@L4@)0CM@J @FPB''@L4@%@CM@J\A$ B''@Y&lt;@) H_@A,@W@F:@@@A$ B&lt;@YH@3PFQ@K0@FPCM@YD@/@CM@K0A$PE]@C&lt;AQ FQ@L4@F@@X@YH@/@CM@J @3PFA@"&lt;A5 GV@I\B@ @@@K0@3PB''@A$@/@@Y@IP@FPCM@A$@%@FQ@Q@@J0CT@L$BB0@1@V0@/ D4@L4@/@FQ@IPA[PG)@[,@&amp;@C=@"@@@@@Y@L4@FPCM@YD@3PFQ@J @3PB1@O(BC@BB@!0@0PBY@WHAJPD)@Z8A)PD&amp;@@L@%@B&lt;@RT@[@FB@#0A/PD5@@@@)0@Y@L4@FPB(@A$@3P@Y@L4@&gt;0HN@_ @6PC1@ND@20@:@Q4@Q@BF@#&lt;@? CM@K0@%@FG@S,A  H&lt;@O4@ZP@@@L4@3PCM@K0@FPB(@L4@/@GW@R(AYPD]@_H@P@E3@I(BP@G3@Z&lt;BE FS@L4@)0B=@J\A @B2@E$BHPH]@",@@@BT@YH@%@@X@IP@3PB(@E(@6@CX@U8@8 G@@Z,A[0A]@J0@_0B1@A @%@CM@J\@3PB2@]P@?0H;@X BG GU@@@@3PCM@L4@%@CM@KD@3PBT@T$A6@A[@O8@"0@I@N4A+@E4@[0A''0CM@K0@*@B1@IPA!0GT@I @W @3@BD@2 @@@J\A$ BT@L4@%@FR@IPA$ B=@N$@0 G*@OTAI0F-@J4A]PE4@J$A% HO@L4BC0B''@[ AB0DW@YPAC@DT@Y0@@@FR@J @3PB(@J @*@CC@"P@K0EG@LPA 0A @W@A( IA@L0AAPB @S0A$0B''@IPA% ET@V0@A G]@^L@2 EE@@@@%@CM@IP@3PBT@L4@%@@"@M\BK@B@@^,@= CU@IH@$ F]@JDAM A-@J\@/@A?@F,@]PG''@P4A80F\@B0A'' @@@K4@%@B(@IP@/PB''@ &lt;A90FN@BLAR C6@\T@= AN@C$@#PE1@S\@*PE-@ &lt;A PEV@CPA%0DI@P(A80DJ@U$@@@BT@L4@%@B(@!@@3PBT@AX@MPEJ@S4A60E @^,A 0G:@PT@G@B[@Q B@ B=@CDA#0AV@^XA$@EE@Q$AFPB9@@@@%@BT@L4@%@B&lt;@ &lt;A7 B:@L8@RPFU@[8BH @\@Z$A%PE @N8AJ0AK@#@@)0B%@Y(A*@DJ@Y8A*@G.@CX@4@@@@IP@*@BT@L4BC0B&lt;@"\@4PCD@\XBOPB[@JD@L E @A0AJ@D"@NLA(0E0@P8AVPA9@^&lt;BG @$@BT@IPEH@N(@@@B=@J @3PBT@IPA$PE&lt;@ITA^PB,@Q(AX AK@!\@* B @YTBO G0@H8A!@AV@MHAWPF(@GXA70C&lt;@@PBDPEK@@@@_0CM@IP@/PEL@E\AEPEJ@],A@@A.@"T@= B@@\\@[0E:@@\A&gt; D+@ L@]PFI@KL@!PBC@G$@!@@6@SHBH0@@@J @%@BT@IP@%@FA@KP@%PB5@L8AEPDD@^ @30DA@S @;0@J@#P@; @2@Y @%0FJ@#LAV0ES@G(A9@@6@W4@@@BT@K4BC0CM@IP@3PF:@OT@(PB4@W$@[ @H@O@A,@E7@R4@B0B"@R&lt;AX@GH@U\@^0E[@TTAB G.@Z A80@6@@@@%@BT@IP@%@B=@IP@/PHP@T$AI@C^@_(BA AA@R,AJ0F1@NHA\@F3@! @\@A''@TTA4 F(@Y@A9 G]@P4@- @@@T0@3PHR@K4@_0CM@ &lt;@/PHO@^0A*PE1@"HA* B)@S(@B F]@VXA-@F&gt;@[$ADP@6@U$BJ@@8@X A2PGJ@XT@@@BT@IP@%@BT@IPAS@BT@ &lt;@/@EX@S0A@ C7@XP@*P@=@N8@6 AC@[DBE0E.@Z@@.PFP@E @_@@8@IX@\PHQ@@@BC0B1@IP@,PEL@KDAS@CM@ &lt;@%@B?@@\@( AL@!PBE@CZ@G4@L@F/@H8A&amp;@@,@F A$@A&lt;@GX@I GI@X BHP@@@K4@%@B(@ &lt;@,PHO@IPASPBT@ &lt;@G E6@Z&lt;@6 BG@DTA=@@0@G4@S0E''@\,AD@BD@P(@.PC*@PL@*0GI@M0@@@A?@K4ASPBT@G&lt;@%@HO@K0BC0CM@ \BO0E_@#\@QPAE@C@AG @0@[&lt;@OPAP@FPAT0B;@P$AC0B&gt;@PLA5 G;@@@@%@HO@ &lt;BC0BT@ &lt;BC0HO@IPBI H5@V @60E_@Q&lt;@QPAE@C,@L@GL@C\BF@@H@P$AVPEY@U$BGPCS@FD@O @@@T4@/PA?@L4ASPB=@G&lt;@/PBT@IPA?@H?@#\BO0AE@DT@L@G4@C@A3PES@C\@&lt;0CE@G0@N@H1@^XBGPDC@M4@@@BT@IP@%@HO@J BD@B1@ &lt;@,PA?@DHAW0C$@I@A=@@0@C@@QP@0@E&lt;@K@H^@@8BP @3@T8@GP@O@FHBA@G1@@@BC0BT@ &lt;@%@EM@K4ASPBT@ &lt;@_0C[@NTAW0E_@C,A=@@0@_8@L@A_@P4BD0@&amp;@W,A)@D&gt;@\(@:0E\@T8@1 @@@ &lt;BC0BT@ &lt;BC0HO@ &lt;BD@B(@D(@Q C[@#&lt;A? G4@H&lt;@!0@0@C,@W0B9@C AS0HQ@J8@70BA@ T@=@H-@U@@@@A?@"XBC0HO@T4BC0A?@#HASPBT@Q,@60C[@I@AK@B/@G4AG0@0@ZP@!PEQ@HD@\ A\@NHA6PE8@F4A#0H6@@@BC0HO@IPASPHO@ &lt;@%@A?@ &lt;BC0@L@UTA) DV@[H@&amp;@BP@DT@P0H?@S&lt;AO0B0@\HA)@BK@Z\@CPH)@GL@6@@@@T4@,PEL@KDAS@B1@T@BC0HO@X,A6 C[@NP@"@D\@D4A=@AE@DTAG GC@]0BE@H8@ TAB0CZ@[P@]PC @Q,@@@HO@ &lt;BI EM@ &lt;BC0BT@G&lt;@,PHO@[4A] AB@_PBP0HH@G4AG0@9@QX@X0B7@D\@S0G,@A@@%0C@@N@A+0@Q@@@@_0B1@G&lt;@/PEM@IP@]@B1@G&lt;@%@HU@M,BO0E_@I0A) D_@Q&lt;A(PD @C0@G0H9@T8A&amp;PGD@[ A8@G5@#TBC0@@@IPASPHO@T4BC0HO@T4@]@EM@ &lt;@C@E6@V @"@HH@DXA=@@;@C@@*0@E@ XBA@BI@[PBBPF[@Z$AY D.@T4@@@A4@K4@_0HO@G&lt;BC0@''@Y(@%@FK@I0AW0BH@H\AX0BX@_X@L@G&gt;@@TA! E$@C0BG0H&lt;@^\A;PB^@[TA&gt;PID@@@BC0EM@ &lt;ASPH&amp;@T@@KPHM@N0BA@E$@_,@''0F4@\8@H@E$@#$BB@HB@@4@7PEZ@C8@?PB%@! A0PE@@T4BEP@@@T4BC0A4@X,@]0A1@A\A30F/@H8BA @(@@,@YPB#@O AX@FL@$HAXPE8@G8@H@F6@PX@10@@@TDBC0B1@O8@@@EM@G&lt;@3PA#@@4@R0B8@$D@S0E)@_\A0@D!@ (BFPHY@@DA-0AK@RH@S@FY@NX@)@BJ@D,AL@A4@!@@]@CM@@@@]@C)@^DAX E&amp;@O$@R0@(@Z8@T C1@SDALPBQ@V(@@ G?@!(AP CU@!PA7@BW@PXBJ DR@EL@/PGP@G&lt;@]@@@@KD@[PDZ@IH@$0E&gt;@D,A=0C''@D8A?0EC@J4@$PH:@MX@@PHJ@TH@JPCL@UHA#PEF@S\@60A&amp;@G&lt;@_0A?@G @@@DS@S\A&lt;0G3@^HA9PH=@SD@8PD!@RL@&amp; BQ@IDAZ GQ@!$BF BL@OL@_PD"@L @J CX@AH@Y BT@G&lt;BD DG@@@@4 G:@H\AZ0@.@ALA]@ED@SD@:@AP@RLB@@D1@I(@E@DH@EP@R@GD@L0@6 @U@!,@UP@Q@G&lt;@_0EL@ &lt;@R @@'))</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Orizi.Farmer</class-id> <category>procedures</category>

<body package="Orizi" selector="figurineAllerA:">figurineAllerA: lieu 
	| x y scaleX scaleY scaledImage scale |
	self class figurine isNil ifFalse: 
			["scaleX := (lieu image component width * 1.2 / self class figurine asImage width) rounded.
			scaleY := (lieu image component height * 1.2 / self class figurine asImage height) rounded.
			scale := (1 max: (scaleX min: scaleY)) @ (1 max: (scaleX min: scaleY)).
			scaledImage := self class figurine asImage magnifiedBy: scale.	
			x := (lieu center x - (lieu image component bounds width / 2.5)) rounded.
			y := (lieu center y - (lieu image component bounds height / 2.5)) rounded."
			self class figurine asImage displayOn: lieu view graphicsContext at: lieu center.
			"lieu displayString: self id printString color: #red"]</body>

<body package="Orizi" selector="id:">id: aValue 
	aValue isString
		ifTrue: [id := aValue asNumber]
		ifFalse: [id := aValue]</body>

<body package="Orizi" selector="moveTo:">moveTo: aPatch 
super moveTo: aPatch
"	aPatch isNil ifTrue: [self halt].  
	self leave.
	self patch: aPatch. 
	""self newPositionCenter;
		defineVisualState. ""
	self center: self patch center. self defineVisualState.
	(self patch theOccupants at: self class name) add: self.
	self displayOn: self patch view graphicsContext."</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Farmer</class-id> <category>init</category>

<body package="Orizi" selector="initFarmer">initFarmer

	super init.
	self satisfaction: 2.
	self memory: 0.
	self irrigation: 1.
	mailBox := OrderedCollection new.</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Farmer</class-id> <category>control</category>

<body package="Orizi" selector="answer">answer
	| m interlocutor mm |
	[self mailBox isEmpty not]
		whileTrue: 
			[m := self mailBox first.
			interlocutor := m sender.
			m symbol = #help ifTrue: [self irrigation = 2 ifTrue: [self satisfaction &gt; 0
						ifTrue: 
							[self irrigation: 1.
							mm := Message new.
							mm symbol: #ok; sender: self; canal: self patch canal; id: self patch id; receiver: interlocutor]]].
			self mailBox remove: m]</body>

<body package="Orizi" selector="close">close
	| tmp1 |
	tmp1 := (self patch plot detect: [:a | a inlet &gt; 0] ifNone: [tmp1 := nil]).
	tmp1 isNil not
		ifTrue: 
			[tmp1 inlet: 0.
			(tmp1 theOccupants at:#Farmer) do: [:b | b irrigation: 1]]</body>

<body package="Orizi" selector="evolDecision">evolDecision
	| tmp1 |
	tmp1 := True.
	self satisfaction = 1 ifTrue: [(self motivation = 1 and: [self labor = 1])
			ifTrue: [tmp1 := False]].
	self satisfaction = 2 ifTrue: [(self motivation = 1 or: [self labor = 1])
			ifTrue: [tmp1 := False]].
	^tmp1</body>

<body package="Orizi" selector="evolIrrigation">evolIrrigation
	self evolDecision = False
		ifTrue: [self irrigation: self irrigation]
		ifFalse: 
			[self irrigation: 2.
			self patch level &gt; (self patch area / 30) ifTrue: [self irrigation: 1]]</body>

<body package="Orizi" selector="evolMemory">evolMemory
	self satisfaction = 0 ifTrue: [self memory: self memory + 1]</body>

<body package="Orizi" selector="evolSatisfaction">evolSatisfaction
	| react tmp1 |
	tmp1 := self patch evolRice.
	tmp1 = 1
		ifTrue: 
			[self irrigation: 1.
			self satisfaction: 2]
		ifFalse: [self patch level &lt; (self patch area / 40)
				ifTrue: [self satisfaction: 0]
				ifFalse: [self patch level &lt; (self patch area / 30) ifTrue: [self satisfaction: 1]]].
	react := 0.
	(self behaviour = 3 and: [self satisfaction = 0])
		ifTrue: [react := 1].
	(self behaviour = 2 and: [self satisfaction = 0])
		ifTrue: [react := 2].
	(self behaviour = 1 and: [self satisfaction = 0])
		ifTrue: [self memory &gt; 0 ifTrue: [react := 2]].
	react = 1 ifTrue: [self close].
	react = 2 ifTrue: [self help].
	self answer.
	self evolMemory</body>

<body package="Orizi" selector="help">help
	| m tmp2 |
	m := Message new.
	m symbol: #help; sender: self; canal: self patch canal; id: self patch id.
	tmp2 := OrderedCollection new.
	self patch plot do: [:a | tmp2 add: (a theOccupants at: #Farmer) first].
	tmp2 do: [:c | self sendMessageAsynchronously: (m receiver: c)]</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Farmer</class-id> <category>pov</category>

<body package="Orizi" selector="povfarmer">povfarmer
	^#farmer</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Farmer</class-id> <category>probes</category>

<body package="Orizi" selector="irrigation">irrigation
^irrigation</body>

<body package="Orizi" selector="satisfaction">satisfaction
^satisfaction</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Farmer</class-id> <category>accessing</category>

<body package="Orizi" selector="behaviour">behaviour
^behaviour</body>

<body package="Orizi" selector="behaviour:">behaviour: aValue
aValue isString ifTrue: [behaviour := aValue asNumber]
ifFalse: [behaviour := aValue]</body>

<body package="Orizi" selector="field">field
^field</body>

<body package="Orizi" selector="field:">field: aValue

aValue isString ifTrue: [field  := aValue asNumber]
ifFalse: [field  := aValue]</body>

<body package="Orizi" selector="irrigation:">irrigation: aValue
irrigation := aValue</body>

<body package="Orizi" selector="labor">labor
^labor</body>

<body package="Orizi" selector="labor:">labor: aValue

aValue isString ifTrue: [labor := aValue asNumber]
ifFalse: [labor := aValue]</body>

<body package="Orizi" selector="memory">memory
^memory</body>

<body package="Orizi" selector="memory:">memory: aValue

aValue isString ifTrue: [memory := aValue asNumber]
ifFalse: [memory := aValue]</body>

<body package="Orizi" selector="motivation">motivation
^motivation</body>

<body package="Orizi" selector="motivation:">motivation: aValue

aValue isString ifTrue: [motivation := aValue asNumber]
ifFalse: [motivation := aValue]</body>

<body package="Orizi" selector="name">name
^name</body>

<body package="Orizi" selector="name:">name: aValue

name := aValue</body>

<body package="Orizi" selector="objective">objective
^objective</body>

<body package="Orizi" selector="objective:">objective: aValue

aValue isString ifTrue: [objective := aValue asNumber]
ifFalse: [objective := aValue]</body>

<body package="Orizi" selector="satisfaction:">satisfaction: aValue

aValue isString ifTrue: [satisfaction:= aValue asNumber]
ifFalse: [satisfaction := aValue]</body>
</methods>


<class>
<name>Orizi</name>
<environment>CormasNS.Models.Orizi</environment>
<super>CormasNS.Kernel.CormasModel</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>theCells theFarmers theRulers theRivers theCanals theDams interface theInterfaces </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Cormas-Orizi</category>
<attributes>
<package>Orizi</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Orizi.Orizi class</class-id> <category>description</category>

<body package="Orizi" selector="authors">authors
^ 'Becu Nicolas
Perez Pascal'</body>

<body package="Orizi" selector="comments">comments
^ 'This model simulates the water management of a small irrigated scheme in central Java (Indonesia).

The scheme is composed of 22 plots belonging and managed each by a single farmer.
Upstream of the scheme is located at the top left of the map and downstream is at the bottom right part of the map. The timestep is one day.

Farmers may have an individualistic water management strategy or a collaborative one (water sharing within water irrigation turns).
Depending on their characteristics (individualistic, collaborative, motivation for farming and labour availability) farmers will choose to irrigate as often as they can or not and will choose to follow the collective water management rules or not.

Outputs of the simulations are farmers'' satisfaction (possibility to irrigate according to their respective goal) and outlet flow at the exit of the scheme (there are three outlets to this scheme corresponding to probes canal3, canal8 and canal9).
'</body>

<body package="Orizi" selector="creationDate">creationDate
^ '2000'</body>

<body package="Orizi" selector="emails">emails
^ 'becu@uni-hohenheim.de
pascal@coombs.anu.edu.au'</body>

<body package="Orizi" selector="howToRunIt">howToRunIt
| txt |
	txt := 'To run Orizi follow these steps

1/ open the space interface,
2 /Click Tessellation and choose Irregular
3/ Choose Topology / Specific Outlines / MIF-MID files ... then click OK, then click Yes
4/ Initialize the model with scenarioChooser as init method and evolOrizi as control method
5/ Pick a scenario from the popping interface and click OK
6/ Select a point of view for the Cell. povCell shows water level of the plots. povFarmerSatisfaction shows plot owner satisfaction
7/ Run the model. The model can be run for a maximum of 119 steps (4 months). One step corresponds to one day.
' asText emphasizeAllWith: #(#bold #large).
	ComposedTextView open: txt asValue
		label: 'How to run ' , self name , '     step-by-step instructions'
		icon: (Icon constantNamed: #workspace)
		extent: 600 @ 300</body>

<body package="Orizi" selector="lastUpdate">lastUpdate
^ 'mardi 12 juin 2007'	</body>

<body package="Orizi" selector="version">version
^ 'Orizi with interface.st'	</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Orizi.Orizi</class-id> <category>accessing</category>

<body package="Orizi" selector="interface">interface
	"Getter accessor without default value "
	^interface</body>

<body package="Orizi" selector="interface:">interface: anObject 
	interface := anObject</body>

<body package="Orizi" selector="theCanals">theCanals
^theCanals ifNil:[theCanals := IndexedSet new]</body>

<body package="Orizi" selector="theCanals:">theCanals: x
theCanals := x</body>

<body package="Orizi" selector="theCells">theCells
^theCells ifNil:[theCells := IndexedSet new]</body>

<body package="Orizi" selector="theCells:">theCells: x
theCells := x</body>

<body package="Orizi" selector="theDams">theDams
^theDams ifNil:[theDams := IndexedSet new]</body>

<body package="Orizi" selector="theDams:">theDams: x
theDams := x</body>

<body package="Orizi" selector="theFarmers">theFarmers
^theFarmers ifNil:[theFarmers := IndexedSet new]</body>

<body package="Orizi" selector="theFarmers:">theFarmers: x
theFarmers := x</body>

<body package="Orizi" selector="theInterfaces">theInterfaces
	"Getter accessor without default value "
	^theInterfaces</body>

<body package="Orizi" selector="theRivers">theRivers
^theRivers ifNil:[theRivers := IndexedSet new]</body>

<body package="Orizi" selector="theRivers:">theRivers: x
theRivers := x</body>

<body package="Orizi" selector="theRulers">theRulers
^theRulers ifNil:[theRulers := IndexedSet new]</body>

<body package="Orizi" selector="theRulers:">theRulers: x
theRulers := x</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Orizi</class-id> <category>init</category>

<body package="Orizi" selector="scenarioChooser">scenarioChooser
	| scenario clickedOK |
	self interface: Interface new.
	self interface model: self.
	clickedOK := self interface open.
	clickedOK 
		ifTrue: 
			[self interface farmersBehaviour value = 'All farmers are cooperative' 
				ifTrue: [scenario := 'allCooperativeFarmers_'].
			self interface farmersBehaviour value = 'All farmers are individualistic' 
				ifTrue: [scenario := 'allIndividualFarmers_'].
			self interface farmersBehaviour value
				= 'Mixt farmers'' behaviour (field data - May 1999)' 
					ifTrue: [scenario := 'realFarmers_'].
			self interface waterLevel value = 'Normal' 
				ifTrue: [scenario := scenario , 'RiverNormal'].
			self interface waterLevel value = 'Dry' 
				ifTrue: [scenario := scenario , 'RiverDry'].
			self perform: scenario asSymbol]</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Orizi</class-id> <category>control</category>

<body package="Orizi" selector="evolOrizi:">evolOrizi: t 
	| tmp1 tmp2 tmp0 tmp11 tmpa tmpb |
	self theRivers
		do: 
			[:a | 
			tmp0 := a evoldischarge.
			a evolday &gt; 119 ifTrue: [self halt]].
	self theDams
		do: 
			[:b | 
			b id = 1
				ifTrue: 
					[b source: tmp0.
					b diversion: b source * 0.5.
					b damid volumin: b diversion.
					b damid canalid do: [:c | c evolLevel: b damid volumin].
					b damid evolVolume.
					tmp11 := b source * 0.5.
					tmp1 := b damid volumout].
			b id = 2
				ifTrue: 
					[b source: tmp11.
					b diversion: b source * 0.8.
					b damid volumin: b diversion.
					b damid canalid do: [:c | c evolLevel: b damid volumin].
					b damid evolVolume.
					tmp2 := b damid volumout].
			b id = 3
				ifTrue: 
					[b source: tmp2 + 1400.
					b diversion: b source.
					b damid volumin: b diversion.
					b damid canalid do: [:c | c evolLevel: b damid volumin].
					b damid evolVolume.
					tmp2 := b damid volumout].
			b id = 4
				ifTrue: 
					[b source: tmp2.
					b diversion: b source.
					b damid volumin: b diversion.
					b damid canalid do: [:c | c evolLevel: b damid volumin].
					b damid evolVolume.
					tmp2 := b damid volumout].
			b id = 5
				ifTrue: 
					[b source: tmp2.
					b diversion: b source.
					b damid volumin: b diversion.
					b damid canalid do: [:c | c evolLevel: b damid volumin].
					b damid evolVolume.
					b damid volumout].
			b id = 6
				ifTrue: 
					[tmpa := self evolDam6.
					b source: tmp11 * 0.2 + tmpa.
					b diversion: b source * 0.8.
					b damid volumin: b diversion.
					b damid canalid do: [:c | c evolLevel: b damid volumin].
					b damid evolVolume.
					tmp2 := b damid volumout].
			b id = 7
				ifTrue: 
					[b source: tmp2 + 700 + tmp1.
					b diversion: b source.
					b damid volumin: b diversion.
					b damid canalid do: [:c | c evolLevel: b damid volumin].
					b damid evolVolume.
					tmp2 := b damid volumout].
			b id = 8
				ifTrue: 
					[b source: tmp2.
					b diversion: b source.
					b damid volumin: b diversion.
					b damid canalid do: [:c | c evolLevel: b damid volumin].
					b damid evolVolume.
					b damid volumout].
			b id = 9
				ifTrue: 
					[tmpb := self evolDam9.
					b source: tmp11 * 0.2 + tmpa * 0.2 + tmpb.
					b diversion: b source * 0.8.
					b damid volumin: b diversion.
					b damid canalid do: [:c | c evolLevel: b damid volumin].
					b damid evolVolume.
					b damid volumout.
					b source * 0.2]].

	self updateData: t.
	(self theFarmers select: [:y | y patch = nil])
		do: [:a | 
				a moveTo: a field].
	self theFarmers do: [:y | y evolIrrigation].
	self theFarmers
		do: 
			[:z | 
			z evolSatisfaction].
	self theFarmers do: [:y | Cormas random &lt; 0.3 ifTrue: [y leave]]</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Orizi</class-id> <category>instance-creation</category>

<body package="Orizi" selector="initAgentsCoop">initAgentsCoop
| |
	super initAgents.
	self theFarmers: OrderedCollection new.
	self readFarmerCoop.
	self initFarmerFields.</body>

<body package="Orizi" selector="initAgentsIndivi">initAgentsIndivi
| |
	super initAgents.
	self theFarmers: OrderedCollection new.
	self readFarmerIndivi.
	self initFarmerFields.</body>

<body package="Orizi" selector="initAgentsReal">initAgentsReal
| |
	super initAgents.
	self theFarmers: OrderedCollection new.
	self readFarmerReal.
	self initFarmerFields.</body>

<body package="Orizi" selector="initCanals">initCanals
| tmp3 |
	self createCanal.
	self theCanals
		do: 
			[:e | 
			tmp3 := e id.
			e canalid
				do: 
					[:f | 
					f canal: tmp3.
					f plot: (self theCells select: [:g | g canal = f canal and: [g id ~= f id]])]]</body>

<body package="Orizi" selector="initFarmerFields">initFarmerFields
	self theCells do: 
			[:x | 
			x farmer isString 
				ifTrue: [x farmer: (self theFarmers detect: [:f | f name = x farmer])]
				ifFalse:[x farmer: (self theFarmers detect: [:f | f name = x farmer name])]].
	self theCells do: 
			[:c | 
			c farmer field: c.
			c farmer field isNil ifTrue:[self halt].
			c farmer moveTo: c]
	"| tmp2 c |
	self theFarmers
		do: 
			[:j | 
			tmp2 := j name.
			self theCells do: [:x | x farmer = tmp2 ifTrue: [	j moveTo: x]].
			j field: (self theCells
					detect: 
						[:cx | 
						c := cx.
						c farmer = tmp2]) id]"</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Orizi</class-id> <category>probes</category>

<body package="Orizi" selector="canal5VolOut">canal5VolOut
	"return the data (a number) to be recorded"

	^(self theCanals detect: [:c | c id = 5]) volumout</body>

<body package="Orizi" selector="canal8VolOut">canal8VolOut
"return the data (a number) to be recorded"
	^(self theCanals detect: [:c | c id = 8]) volumout</body>

<body package="Orizi" selector="canal9VolOut">canal9VolOut
"return the data (a number) to be recorded"
	^(self theCanals detect: [:c | c id = 9]) volumout</body>

<body package="Orizi" selector="percSatisfiedFarmer">percSatisfiedFarmer
	"return the data (a number) to be recorded"

	^(self theFarmers select: [:f | f satisfaction &gt;= 1])size
		/ self theFarmers size</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Orizi</class-id> <category>scenarios</category>

<body package="Orizi" selector="allCooperativeFarmers_RiverDry">allCooperativeFarmers_RiverDry
	self initCells.
	self theCells: (self theCells asSortedCollection: [:x :y | x id &lt; y id]).
	self initAgentsCoop.
	self readRice.
	self initCanals.
	self readRiverDry.
	self createDam.
	self initData.</body>

<body package="Orizi" selector="allCooperativeFarmers_RiverNormal">allCooperativeFarmers_RiverNormal
	
	self initCells.
	self theCells: (self theCells asSortedCollection: [:x :y | x id &lt; y id]).
	self initAgentsCoop.
	self readRice.
	self initCanals.
	self readRiver.
	self createDam.
	self initData.</body>

<body package="Orizi" selector="allIndividualFarmers_RiverDry">allIndividualFarmers_RiverDry
	self initCells.
	self theCells: (self theCells asSortedCollection: [:x :y | x id &lt; y id]).
	self initAgentsIndivi.
	self readRice.
	self initCanals.
	self readRiverDry.
	self createDam.
	self initData.</body>

<body package="Orizi" selector="allIndividualFarmers_RiverNormal">allIndividualFarmers_RiverNormal
	self initCells.
	self theCells: (self theCells asSortedCollection: [:x :y | x id &lt; y id]).
	self initAgentsIndivi.
	self readRice.
	self initCanals.
	self readRiverDry.
	self createDam.
	self initData.</body>

<body package="Orizi" selector="realFarmers_RiverDry">realFarmers_RiverDry
	self initCells.
	self theCells: (self theCells asSortedCollection: [:x :y | x id &lt; y id]).
	self initAgentsReal.
	self readRice.
	self initCanals.
	self readRiverDry.
	self createDam.
	self initData.</body>

<body package="Orizi" selector="realFarmers_RiverNormal">realFarmers_RiverNormal
	self initCells.
	self theCells: (self theCells asSortedCollection: [:x :y | x id &lt; y id]).
	self initAgentsReal.
	self readRice.
	self initCanals.
	self readRiverDry.
	self createDam.
	self initData.</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Orizi</class-id> <category>procedures</category>

<body package="Orizi" selector="createCanal">createCanal
	| i e f |
	self theCanals: OrderedCollection new.
	i := 1.
	[i &lt; 10]
		whileTrue: 
			[e := 10 * i.
			f := Canal new.
			f initCanal: i.
			f canalid: (self theCells select: [:d | d id &gt; e and: [d id &lt; (10 + e)]]).
			self theCanals add: f.
			i := i + 1]</body>

<body package="Orizi" selector="createDam">createDam
	| i f |
	self theDams: OrderedCollection new.
	i := 1.
	[i &lt; 10]
		whileTrue: 
			[f := Dam new.
			f initDam.
			f id: i.
			f damid: (self theCanals detect: [:d | d id = i]).
			self theDams add: f.
			i := i + 1]</body>

<body package="Orizi" selector="evolDam6">evolDam6
	| temp1 tmp2 tmp3 |
	temp1 := OrderedCollection new.
	tmp3 := 0.
	temp1 := self theCells select: [:a | a id &lt; 40].
	temp1
		do: 
			[:b | 
			tmp2 := b outlet.
			tmp3 := tmp3 + tmp2].
	^tmp3</body>

<body package="Orizi" selector="evolDam9">evolDam9
	| temp1 tmp2 tmp3 |
	temp1 := OrderedCollection new.
	tmp3 := 0.
	temp1 := self theCells select: [:a | a id &gt; 40 and: [a id &lt; 80]].
	temp1
		do: 
			[:b | 
			tmp2 := b outlet.
			tmp3 := tmp3 + tmp2].
	^tmp3</body>

<body package="Orizi" selector="readFarmerCoop">readFarmerCoop
	| stream listword c |
	stream := (((Cormas dataPath: self class name) construct: 'farmcoop.csv')) readStream.
	listword := Cormas splitLine: stream sep: $,.
	22
		timesRepeat: 
			[listword := Cormas splitLine: stream sep: $,.
			c := Farmer new.
			c id: (listword at: 1).
			c name: (listword at: 2).
			c motivation: (listword at: 3).
			c labor: (listword at: 4).
			c behaviour: (listword at: 5).
			c objective: (listword at: 6).
			c initFarmer.
			self theFarmers add: c].
	stream close</body>

<body package="Orizi" selector="readFarmerIndivi">readFarmerIndivi
	| stream listword c |
	stream := (((Cormas dataPath: self class name) construct: 'farmind.csv')) readStream.
	listword := Cormas splitLine: stream sep: $,.
	22
		timesRepeat: 
			[listword := Cormas splitLine: stream sep: $,.
			c := Farmer new.
			c id: (listword at: 1).
			c name: (listword at: 2).
			c motivation: (listword at: 3).
			c labor: (listword at: 4).
			c behaviour: (listword at: 5).
			c objective: (listword at: 6).
			c initFarmer.
			self theFarmers add: c].
	stream close</body>

<body package="Orizi" selector="readFarmerReal">readFarmerReal
	| stream listword c |
	stream := (((Cormas dataPath: self class name) construct: 'farmers.csv')) readStream.
	listword := Cormas splitLine: stream sep: $,.
	22
		timesRepeat: 
			[listword := Cormas splitLine: stream sep: $,.
			c := Farmer new.
			c id: (listword at: 1).
			c name: (listword at: 2).
			c motivation: (listword at: 3).
			c labor: (listword at: 4).
			c behaviour: (listword at: 5).
			c objective: (listword at: 6).
			c initFarmer.
			self theFarmers add: c].
	stream close</body>

<body package="Orizi" selector="readRice">readRice
	| stream listword c tmp1 tmp2 |
	stream := ((Cormas dataPath: self class name) construct: 'rice.csv')  readStream.
	self theCells
		do: 
			[:cx | 
			c := cx.
			c theOccupants
				do: 
					[:d | tmp2 := d first objective].
			stream reset.
			tmp1 := OrderedCollection new.
			tmp2 = 1
				ifTrue: 
					[listword := Cormas splitLine: stream sep: $,.
					120
						timesRepeat: 
							[listword := Cormas splitLine: stream sep: $,.
							tmp1 add: (listword at: 2)].
					c rice: tmp1].
			tmp2 = 2
				ifTrue: 
					[listword := Cormas splitLine: stream sep: $,.
					120
						timesRepeat: 
							[listword := Cormas splitLine: stream sep: $,.
							tmp1 add: (listword at: 3)].
					c rice: tmp1].
			tmp2 = 3
				ifTrue: 
					[listword := Cormas splitLine: stream sep: $,.
					120
						timesRepeat: 
							[listword := Cormas splitLine: stream sep: $,.
							tmp1 add: (listword at: 4)].
					c rice: tmp1]].
	stream close.</body>

<body package="Orizi" selector="readRiver">readRiver
	| stream listword c tmp1 tmp2 |
	stream := ((Cormas dataPath: self class name)
				construct: 'river.csv') readStream.
	self theRivers: OrderedCollection new.
	c := River new initRiver.
	tmp1 := OrderedCollection new.
	tmp2 := OrderedCollection new.
	listword := Cormas splitLine: stream sep: $,.
	120
		timesRepeat: 
			[listword := Cormas splitLine: stream sep: $,.
			tmp1 add: (listword at: 1).
			tmp2 add: (listword at: 2)].
	c day: tmp1.
	c discharge: tmp2.
	theRivers add: c.
	stream close</body>

<body package="Orizi" selector="readRiverDry">readRiverDry
	| stream listword c tmp1 tmp2 |
	stream := ((Cormas dataPath: self class name)
				construct: 'rivdry.csv') readStream.
	self theRivers: OrderedCollection new.
	c := River new initRiver.
	tmp1 := OrderedCollection new.
	tmp2 := OrderedCollection new.
	listword := Cormas splitLine: stream sep: $,.
	120
		timesRepeat: 
			[listword := Cormas splitLine: stream sep: $,.
			tmp1 add: (listword at: 1).
			tmp2 add: (listword at: 2)].
	c day: tmp1.
	c discharge: tmp2.
	theRivers add: c.
	stream close</body>
</methods>


<class>
<name>Cell</name>
<environment>CormasNS.Models.Orizi</environment>
<super>CormasNS.Kernel.SpatialEntityElement</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>plot farmer area canal rice level aet outlet includedComponents inlet </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Cormas-Orizi</category>
<attributes>
<package>Orizi</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.Orizi.Cell</class-id> <category>init</category>

<body package="Orizi" selector="init">init
	| |
	super init.
	self request: OrderedCollection new.
	self theCSE: Dictionary new.
	self canal: 0.
	self rice: OrderedCollection new.
	self level: self area / 20.
	self aet: self area / 100.
	self outlet: 0.
	self inlet: 0.
	self plot: SortedCollection new.</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Cell</class-id> <category>control</category>

<body package="Orizi" selector="evolLevel:">evolLevel: x 
	| tmp1 tmp0 tmp2 tmp3 tmp4 tmp5 tmp6 |
	tmp0 := OrderedCollection new.
	tmp0 := self plot select: [:a | a id &lt; self id].
	tmp2 := 0.
	tmp0
		do: 
			[:b | 
			tmp1 := b inlet.
			tmp1 isNil ifTrue: [tmp1 := 0].
			tmp2 := tmp2 + tmp1].
	tmp3 := x - tmp2.
	tmp3 &gt; (self area / 10)
		ifTrue: [self inlet: self area / 10]
		ifFalse: [self inlet: tmp3].
	(self theOccupants at: #Farmer) isEmpty
		ifTrue: [tmp4 := 1]
		ifFalse: [self theOccupants do: [:a | tmp4 := a first irrigation]].
	tmp4 = 1 ifTrue: [self inlet: 0].
	tmp5 := self area / 100.
	tmp6 := self area / 20.
	self level &gt; tmp5
		ifTrue: [self aet: tmp5]
		ifFalse: [self aet: self level].
	self level: self level + self inlet - self aet.
	self level &gt; tmp6
		ifTrue: 
			[self outlet: self level - tmp6.
			self level: tmp6]
		ifFalse: [self outlet: 0].</body>

<body package="Orizi" selector="evolRice">evolRice
| tmp1 |
	tmp1 := self rice first.
	tmp1 isString ifTrue: [tmp1 := tmp1 asNumber].
	self rice removeFirst.
	^tmp1</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Cell</class-id> <category>pov</category>

<body package="Orizi" selector="povCell">povCell
	(self level isNil or: [self area isNil])
		ifTrue: [^#rien].
	self level &lt; (self area / 40)
		ifTrue: [^#low]
		ifFalse: [self level &lt; (self area / 20)
				ifTrue: [^#medium]
				ifFalse: [^#high]]</body>

<body package="Orizi" selector="povFarmerSatisfaction">povFarmerSatisfaction
(self farmer satisfaction isNil or: [self area isNil]) ifTrue: [^#rien].
self farmer satisfaction = 0 ifTrue: [^#low].
self farmer satisfaction = 1 ifTrue: [^#medium].
self farmer satisfaction = 2 ifTrue: [^#high]</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Cell</class-id> <category>accessing</category>

<body package="Orizi" selector="aet">aet
^aet</body>

<body package="Orizi" selector="aet:">aet: aValue
aet := aValue</body>

<body package="Orizi" selector="area">area
^area</body>

<body package="Orizi" selector="area:">area: aValue
aValue isString ifTrue: [area:= aValue asNumber] ifFalse: [area := aValue].
 self defineVisualState; show</body>

<body package="Orizi" selector="canal">canal
^canal</body>

<body package="Orizi" selector="canal:">canal: aValue
canal := aValue</body>

<body package="Orizi" selector="farmer">farmer
	"Getter accessor without default value "
	^farmer</body>

<body package="Orizi" selector="farmer:">farmer: anObject 
	farmer := anObject</body>

<body package="Orizi" selector="id:">id: aValue 
	aValue isString
		ifTrue: [id := aValue asNumber]
		ifFalse: [id := aValue]</body>

<body package="Orizi" selector="includedComponents">includedComponents
^includedComponents</body>

<body package="Orizi" selector="includedComponents:">includedComponents: uneValeur
includedComponents := uneValeur</body>

<body package="Orizi" selector="inlet:">inlet: aValue
inlet := aValue</body>

<body package="Orizi" selector="level:">level: aValue
level := aValue.
self defineVisualState; show</body>

<body package="Orizi" selector="outlet">outlet
^outlet</body>

<body package="Orizi" selector="outlet:">outlet: aValue
outlet := aValue</body>

<body package="Orizi" selector="plot">plot
^plot</body>

<body package="Orizi" selector="plot:">plot: aValue
aValue isString ifTrue: [plot:= aValue asNumber] ifFalse: [plot := aValue].
" self defineVisualState; show"</body>

<body package="Orizi" selector="rice">rice
^rice</body>

<body package="Orizi" selector="rice:">rice: aValue
rice := aValue</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Cell</class-id> <category>probes</category>

<body package="Orizi" selector="inlet">inlet
^inlet</body>

<body package="Orizi" selector="level">level
^level</body>
</methods>


<class>
<name>Canal</name>
<environment>CormasNS.Models.Orizi</environment>
<super>CormasNS.Kernel.PassiveObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>canalid volumin volumout </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Cormas-Orizi</category>
<attributes>
<package>Orizi</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.Orizi.Canal</class-id> <category>procedures</category>

<body package="Orizi" selector="canalid">canalid
^canalid</body>

<body package="Orizi" selector="canalid:">canalid: aValue
canalid := aValue</body>

<body package="Orizi" selector="volumin:">volumin: aValue
volumin := aValue</body>

<body package="Orizi" selector="volumout:">volumout: aValue
volumout := aValue</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Canal</class-id> <category>init</category>

<body package="Orizi" selector="initCanal:">initCanal: i 

	canalid := SortedCollection new.
	self volumin: 0.
	self volumout: 0.
	self id: i.</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Canal</class-id> <category>control</category>

<body package="Orizi" selector="evolVolume">evolVolume
	| tmp2 tmp1 |
	tmp2 := 0.
	self canalid
		do: 
			[:a | 
			tmp1 := a inlet.
			tmp2 := tmp2 + tmp1].
	self volumout: volumin - tmp2.</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Canal</class-id> <category>probes</category>

<body package="Orizi" selector="volumin">volumin
^volumin</body>

<body package="Orizi" selector="volumout">volumout
^volumout</body>
</methods>


<class>
<name>Message</name>
<environment>CormasNS.Models.Orizi</environment>
<super>CormasNS.Kernel.Msg</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>canal id </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Cormas-Orizi</category>
<attributes>
<package>Orizi</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.Orizi.Message</class-id> <category>procedures</category>

<body package="Orizi" selector="canal">canal
^canal</body>

<body package="Orizi" selector="canal:">canal: uneValeur
canal := uneValeur</body>

<body package="Orizi" selector="id">id
^id</body>

<body package="Orizi" selector="id:">id: uneValeur
id := uneValeur</body>
</methods>


<class>
<name>Ruler</name>
<environment>CormasNS.Models.Orizi</environment>
<super>CormasNS.Kernel.AgentComm</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>rule memory penalty </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Cormas-Orizi</category>
<attributes>
<package>Orizi</package>
</attributes>
</class>

<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.Orizi.Ruler</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>Orizi</package>
</attributes>
</shared-variable>

<methods>
<class-id>CormasNS.Models.Orizi.Ruler</class-id> <category>procedures</category>

<body package="Orizi" selector="memory">memory
^memory</body>

<body package="Orizi" selector="memory:">memory: aValue
memory := aValue</body>

<body package="Orizi" selector="penalty">penalty
^penalty</body>

<body package="Orizi" selector="penalty:">penalty: aValue
penalty := aValue</body>

<body package="Orizi" selector="rule">rule
^rule</body>

<body package="Orizi" selector="rule:">rule: aValue
rule := aValue</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Ruler</class-id> <category>init</category>

<body package="Orizi" selector="initRuler">initRuler
	super initialize.
	mailBox := OrderedCollection new</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Ruler</class-id> <category>control</category>

<body package="Orizi" selector="evolMemory">evolMemory
	| m |
	m := self nextMessage.
	m notNil ifTrue: 
			[self processMessage: m.
			m := self nextMessage]</body>

<body package="Orizi" selector="evolPenalty">evolPenalty
	| m |
	m := self nextMessage.
	m notNil ifTrue: 
			[self processMessage: m.
			m := self nextMessage]</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Ruler</class-id> <category>id</category>

<body package="Orizi" selector="CurrentId">CurrentId
	^CurrentId isNil ifTrue: [0] ifFalse: [CurrentId]</body>

<body package="Orizi" selector="CurrentId:">CurrentId: x
	^CurrentId := x</body>

<body package="Orizi" selector="initId">initId
	self id: (self CurrentId: self CurrentId + 1)</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Ruler</class-id> <category>pov</category>

<body package="Orizi" selector="povruler">povruler
	^#ruler</body>
</methods>


<class>
<name>Dam</name>
<environment>CormasNS.Models.Orizi</environment>
<super>CormasNS.Kernel.PassiveObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>damid diversion source </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Cormas-Orizi</category>
<attributes>
<package>Orizi</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.Orizi.Dam</class-id> <category>procedures</category>

<body package="Orizi" selector="damid">damid
^damid</body>

<body package="Orizi" selector="damid:">damid: aValue
damid := aValue</body>

<body package="Orizi" selector="diversion">diversion
^diversion</body>

<body package="Orizi" selector="diversion:">diversion: aValue
diversion := aValue</body>

<body package="Orizi" selector="source">source
^source</body>

<body package="Orizi" selector="source:">source: aValue
source := aValue</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Dam</class-id> <category>init</category>

<body package="Orizi" selector="initDam">initDam
	self id: 0.
	self diversion: 0.
	self source: 0.
	self damid: 0</body>
</methods>


<class>
<name>Interface</name>
<environment>CormasNS.Models.Orizi</environment>
<super>UI.SimpleDialog</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Cormas-Orizi</category>
<attributes>
<package>Orizi</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Orizi.Interface class</class-id> <category>interface specs</category>

<body package="Orizi" selector="windowSpec">windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"

	&lt;resource: #canvas&gt;
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#label: 'Scenario Chooser' 
			#min: #(#{Core.Point} 398 239 ) 
			#max: #(#{Core.Point} 398 239 ) 
			#bounds: #(#{Graphics.Rectangle} 512 384 910 623 ) 
			#isEventDriven: true ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #(
				#(#{UI.LabelSpec} 
					#layout: #(#{Core.Point} 71 9 ) 
					#colors: 
					#(#{UI.LookPreferences} 
						#setForegroundColor: #(#{Graphics.ColorValue} #blue ) ) 
					#label: 'Choose a scenario by selecting' 
					#style: #large ) 
				#(#{UI.ActionButtonSpec} 
					#layout: #(#{Graphics.Rectangle} 106 181 173 220 ) 
					#name: #ActionButton1 
					#model: #accept 
					#callbacksSpec: 
					#(#{UI.UIEventCallbackSubSpec} 
						#requestFocusInSelector: #'This action will stop Cormas from recording data' ) 
					#tabable: false 
					#label: 'OK' 
					#isDefault: true 
					#defaultable: true ) 
				#(#{UI.GroupBoxSpec} 
					#layout: #(#{Graphics.Rectangle} 92 159 319 229 ) 
					#name: #GroupBox2 
					#colors: 
					#(#{UI.LookPreferences} 
						#setForegroundColor: #(#{Graphics.ColorValue} 8191 1024 1024 ) ) 
					#label: 'Confirm scenario' ) 
				#(#{UI.LabelSpec} 
					#layout: #(#{Core.Point} 16 34 ) 
					#name: #Label1 
					#colors: 
					#(#{UI.LookPreferences} 
						#setForegroundColor: #(#{Graphics.ColorValue} #blue ) ) 
					#label: 'water availability level and farmers behaviour type' 
					#style: #large ) 
				#(#{UI.ComboBoxSpec} 
					#layout: #(#{Graphics.Rectangle} 218 94 318 116 ) 
					#name: #ComboBox1 
					#model: #waterLevel 
					#comboList: #waterLevelList ) 
				#(#{UI.ComboBoxSpec} 
					#layout: #(#{Graphics.Rectangle} 164 124 384 149 ) 
					#name: #ComboBox2 
					#model: #farmersBehaviour 
					#comboList: #farmersBehaviourList ) 
				#(#{UI.LabelSpec} 
					#layout: #(#{Core.Point} 10 87 ) 
					#name: #Label2 
					#label: 'Water available at the river:' 
					#style: #large ) 
				#(#{UI.LabelSpec} 
					#layout: #(#{Core.Point} 10 119 ) 
					#name: #Label3 
					#label: 'Farmers'' behaviour:' 
					#style: #large ) 
				#(#{UI.ActionButtonSpec} 
					#layout: #(#{Graphics.Rectangle} 213 180 280 219 ) 
					#name: #ActionButton2 
					#model: #cancel 
					#callbacksSpec: 
					#(#{UI.UIEventCallbackSubSpec} 
						#requestFocusInSelector: #'This action will stop Cormas from recording data' ) 
					#tabable: false 
					#label: 'Cancel' 
					#isDefault: false 
					#defaultable: true ) ) ) )</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Interface class</class-id> <category>accessing</category>

<body package="Orizi" selector="activePov:">activePov: anything</body>

<body package="Orizi" selector="activeProbes">activeProbes
^List new</body>

<body package="Orizi" selector="activeProbes:">activeProbes: anything</body>

<body package="Orizi" selector="colorsDict">colorsDict
^nil</body>

<body package="Orizi" selector="image">image
^nil</body>

<body package="Orizi" selector="probes">probes
^List new</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Orizi.Interface</class-id> <category>aspects</category>

<body package="Orizi" selector="farmersBehaviour">farmersBehaviour
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^farmersBehaviour isNil
		ifTrue:
			[farmersBehaviour := String new asValue]
		ifFalse:
			[farmersBehaviour]</body>

<body package="Orizi" selector="farmersBehaviourList">farmersBehaviourList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	| list |
	list := List new.
	list
		add: 'All farmers are cooperative';
		add: 'All farmers are individualistic';
		add: 'Mixt farmers'' behaviour (field data - May 1999)'.
	^farmersBehaviourList isNil
		ifTrue:
			[farmersBehaviourList := list asValue]
		ifFalse:
			[farmersBehaviourList]</body>

<body package="Orizi" selector="waterLevel">waterLevel
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^waterLevel isNil
		ifTrue:
			[waterLevel := String new asValue]
		ifFalse:
			[waterLevel]</body>

<body package="Orizi" selector="waterLevelList">waterLevelList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	| list |
	list := List new.
	list
		add: 'Normal';
		add: 'Dry'.
	^waterLevelList isNil
		ifTrue:
			[waterLevelList := list asValue]
		ifFalse:
			[waterLevelList]</body>

<body package="Orizi" selector="waterLevelsUI">waterLevelsUI
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	| list |
	list := List new.
	list
		add: 'Normal';
		add: 'Dry'.
	^waterLevelsUI isNil 
		ifTrue: [waterLevelsUI := list asValue]
		ifFalse: [waterLevelsUI]</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Interface</class-id> <category>actions</category>

<body package="Orizi" selector="accept">accept

	"This stub method was generated by UIDefiner"

	^self</body>

<body package="Orizi" selector="cancel">cancel

	"This stub method was generated by UIDefiner"

	^self</body>

<body package="Orizi" selector="confirmScenario">confirmScenario

	"This stub method was generated by UIDefiner"

	^self</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.Interface</class-id> <category>accessing</category>

<body package="Orizi" selector="model">model
	"Getter accessor without default value "
	^model</body>

<body package="Orizi" selector="model:">model: anObject 
	model := anObject</body>
</methods>


<class>
<name>River</name>
<environment>CormasNS.Models.Orizi</environment>
<super>CormasNS.Kernel.PassiveObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>discharge day </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Cormas-Orizi</category>
<attributes>
<package>Orizi</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.Orizi.River</class-id> <category>accessing</category>

<body package="Orizi" selector="day">day
^day</body>

<body package="Orizi" selector="day:">day: aValue
aValue isString ifTrue: [day := aValue asNumber]
ifFalse: [day := aValue]</body>

<body package="Orizi" selector="discharge">discharge
^discharge</body>

<body package="Orizi" selector="discharge:">discharge: aValue
aValue isString ifTrue: [discharge := aValue asNumber]
ifFalse: [discharge := aValue]</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.River</class-id> <category>init</category>

<body package="Orizi" selector="initRiver">initRiver
	self discharge: OrderedCollection new.
	self day: OrderedCollection new.
	self id: 1</body>
</methods>

<methods>
<class-id>CormasNS.Models.Orizi.River</class-id> <category>control</category>

<body package="Orizi" selector="evolday">evolday
	| tmp1 |
	tmp1 := self day first.
	tmp1 isString ifTrue: [tmp1 := tmp1 asNumber].
	self day removeFirst.
	^tmp1</body>

<body package="Orizi" selector="evoldischarge">evoldischarge
	| tmp1 |
	tmp1 := self discharge first.
	tmp1 isString ifTrue: [tmp1 := tmp1 asNumber].
	self discharge removeFirst.
	^tmp1</body>
</methods>



</st-source>
